$fs = 0.1;
$fa = 1;  

module chassisboy(){
    difference(){
    color("Lime") translate([0,0,2]) cylinder(h=4, r=25, center=true, $fn=100);   
    translate([-9.8,18.8,0]) resetbottomhole();
        }
}

module chassisbase(){
    difference(){
    color("Lime") translate([0,0,-0.325]) cylinder(h=0.75, r=26, center=true, $fn=100);   

        }
}

module motorbody(){
color("red")
    translate([0,0,0]) 
    linear_extrude(height = 12, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-5.5,-8.25],[5.5,-8.25],[5.5,8.25],[-5.5,8.25],[-5.5,-8.25]]);}
color("red")
    translate([0,-8.4,2]) 
    rotate([90,0,0])
    linear_extrude(height = 0.3, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-5.5,-4],[5.5,-4],[5.5,4],[-5.5,4],[-5.5,-4]]);} 
 color("blue")   
    translate([1.545,15.25,0]) 
    rotate([90,90,0]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 3.95, $fn=200);}
  color("lime")   
    translate([-5.75,-3.25,0]) 
    rotate([0,90,0]) 
    linear_extrude(height = 0.5, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 2.5, $fn=200);}
    
    intersection(){
color("lime")   
    translate([-7.5,-3.25,0]) 
    rotate([0,90,0]) 
    linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.5, $fn=200);}
color("aquamarine")
    translate([-7.5,-3.25,0]) rotate([0,90,0])
    linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-2,-1.2],[2,-1.2],[2,1.2],[-2,1.2],[-2,-1.2]]);}
    }
  color("lime")   
    translate([5.75,3.5,0]) 
    rotate([0,90,0]) 
    linear_extrude(height = 0.5, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.25, $fn=200);}
color("purple")
    translate([-14.5,-3.25,-5]) 
    rotate([0,0,0])
    linear_extrude(height = 4, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-9,-9],[9,-9],[9,9],[-9,9],[-9,-9]]);} 
}

module motorbodycut(){
    
 mirror([0,0,0]) motorbody();
    
mirror([0,0,0]) color("red")
    translate([-16.5,0,0]) 
    linear_extrude(height = 12, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-11,-8.25],[11,-8.25],[11,8.25],[-11,8.25],[-11,-8.25]]);}
mirror([0,0,0]) color("blue")
    translate([-9.25,15.25,-0.95]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-11,-7],[11,-7],[11,7],[-11,7],[-11,-7]]);}  
mirror([0,0,0]) color("blue")
    translate([-16.5,15.25,-0.95]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-11,-7],[11,-7],[11,7],[-11,7],[-11,-7]]);}
     
}    


module motcut(){

translate([5.75,3.25,7]) mirror([0,90,0]) rotate([0,0,180])  motorbodycut();
translate([-5.75,-3.25,7]) mirror([0,90,0]) motorbodycut();
}









module motorbodyb(){
color("red")
    translate([0,0,0]) 
    linear_extrude(height = 12, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-5.5,-8.25],[5.5,-8.25],[5.5,8.25],[-5.5,8.25],[-5.5,-8.25]]);}
color("red")
    translate([0,-8.4,2]) 
    rotate([90,0,0])
    linear_extrude(height = 0.3, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-5.5,-4],[5.5,-4],[5.5,4],[-5.5,4],[-5.5,-4]]);} 
 color("blue")   
    translate([1.545,15.25,0]) 
    rotate([90,90,0]) 
    linear_extrude(height = 14, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 3.95, $fn=100);}
  color("lime")   
    translate([-5.75,-3.25,0]) 
    rotate([0,90,0]) 
    linear_extrude(height = 0.5, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 2.5, $fn=100);}
    
    intersection(){
color("lime")   
    translate([-7.5,-3.25,0]) 
    rotate([0,90,0]) 
    linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.5, $fn=100);}
color("aquamarine")
    translate([-7.5,-3.25,0]) rotate([0,90,0])
    linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-2,-1.2],[2,-1.2],[2,1.2],[-2,1.2],[-2,-1.2]]);}
    }
  color("lime")   
    translate([5.75,3.5,0]) 
    rotate([0,90,0]) 
    linear_extrude(height = 0.5, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.25, $fn=100);}
color("blue")
    translate([-9.25,15.25,-0.95]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-11,-7],[11,-7],[11,7],[-11,7],[-11,-7]]);} 
    
}


module motorholderpart() {
color("aquamarine")
    translate([1.5,13.25,1.05]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-6,-5],[6,-5],[6,5],[-6,5],[-6,-5]]);}
 
    color("aquamarine") rotate([0,135,270])
    translate([-10,2,9]) cylinder(h=13.5, r=1.5, center=true, $fn=100);
    color("aquamarine") rotate([0,135,270])
    translate([-10,-2,9]) cylinder(h=13.5, r=1.5, center=true, $fn=100);

    
    color("aquamarine")rotate([0,0,270])
    translate([8.5,0,5.75]) 
    linear_extrude(height = 4, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-2,-5],[2,-5],[2,5],[-2,5],[-2,-5]]);}
}

module motorholdercut(){
    mirror([90,0,0]) translate([1.5,-1.75,-6.95])
difference(){
color("blue")
    translate([-3,15,10.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-6,-5],[6,-5],[6,5],[-6,5],[-6,-5]]);}
color("blue")
    translate([0,15,10.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-3,-5],[3,-5],[3,5],[-3,5],[-3,-5]]);}
color("yellow")    
    rotate([90,90,0]) 
    translate([-7,-3,-15]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 6.1, $fn=100);}
}
}


module motorholder() {
    
    difference() {
    motorholderpart();
    motorholdercut();
       motorbodyb();
        }
    
}



//translate([9.8,-18.8,0]) resetbottom();



module resetbottom() {
    color("pink") translate([0,0,2])     
    linear_extrude(height = 4, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 3.75, $fn=100);}
}


module resetbottomhole() {
    color("blue") translate([0,0,2])     
    linear_extrude(height = 4, center = true, convexity = 10, scale = 1.5, $fn=10){
    circle(r = 1.75, $fn=100);}
}


module resethold() {
    color("yellow") translate([3, 0, 8]) rotate([0, 157.5, 0])
    linear_extrude(height = 12, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1, $fn=100);} 
       color("yellow") translate([0, -3, 8]) rotate([157.5, 0, 0])
    linear_extrude(height = 12, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1, $fn=100);}   
}


module resetbutton() {
    color("red")    translate([0, 0, 7.5])
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1, $fn=100);} 
}

module resettop() {
    color("red")  translate([0, 0, 12.5])
    linear_extrude(height = 1, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 2.5, $fn=100);} 
    color("red")  rotate ([0,180,0])  translate([0, 0, -14])
    linear_extrude(height = 2, center = true, convexity = 10, scale = 2.5, $fn=100){
    circle(r = 1, $fn=100);} 
}

module reset(){
resettop();
resethold();
//rotate ([0,0,310]) {resethold();}
resetbutton();

}





module holeai(){
color("pink")
    translate([0,0,0]) 
    linear_extrude(height = 18, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.1, $fn=100);}
    }
module holeao(){
color("red")
    translate([0,0,0]) 
    linear_extrude(height = 18, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.75, $fn=100);}  
    }
    
module holea(){
    difference() {
    holeao();
    holeai();
    }
}





module holeir(){
color("red")
    translate([0,5.4462,10]) 
    linear_extrude(height = 12, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.1, $fn=100);}  
    }


module holear(){
color("red")
    translate([0,5.4462,12]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.75, $fn=100);}  
    }
  module holebr(){
color("red")
    translate([0,0,4]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 2.25, $fn=100);}  
    }  
  module holecr(){
color("red")
    rotate([135,0,0]) translate([0,4.5,-8]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.75, $fn=100);}  
    }  
    
module screwholdr(){
    translate([0,-5.4462,0])
    difference(){
union (){
holear();
holebr();
holecr();
}
holeir();
}
translate([0,0,0]) supportscrew();
}


    
    
module holeib(){
color("blue")
    translate([0,4.031128,12]) 
    linear_extrude(height = 14, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.1, $fn=100);}  
    }

module holeab(){
color("blue")
    translate([0,4.031128,12]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.75, $fn=100);}  
    }
  module holebb(){
color("blue")
    translate([0,0,4]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 2.25, $fn=100);}  
    }  
  module holecb(){
color("blue")
    rotate([135,0,0]) translate([0,5,-7.5]) 
    linear_extrude(height = 6.5, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.75, $fn=100);}  
    }  
    
module screwholdb(){
    translate([0,-4.031128,0])
    difference(){
union (){
holeab();
holebb();
holecb();
}
holeib();
}
translate([0,0,0]) supportscrew();
}

    
    module supportscrew(){
    
    translate([1.35,0,4]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    translate([-1.35,0,4]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}  
    translate([0,1.35,4]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}    
    
        
    }
    
    
    
    
    
    
    
    
    
module suport()
{
color("yellow") 
   rotate([0,0,270])
    translate([7,4,4.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    rotate([0,0,270])translate([7,2,4.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    rotate([0,0,270])translate([7,0,4.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    rotate([0,0,270])translate([7,-2,4.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);} 
    rotate([0,0,270])translate([7,-4,4.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);} 
    
    
    
    rotate([0,0,270])
    translate([4.9,4,11.25]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    rotate([0,0,270])translate([4.9,2,11.25]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    rotate([0,0,270])translate([4.9,0,11.25]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    rotate([0,0,270])translate([4.9,-2,11.25]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);} 
    rotate([0,0,270])translate([4.9,-4,11.25]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);} 
    
    
    rotate([0,135,270]) translate([-10,4,2.5]) 
    linear_extrude(height = 11, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,135,270]) translate([-10,2,2.5]) 
    linear_extrude(height = 11, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,135,270]) translate([-10,0,2.5]) 
    linear_extrude(height = 11, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,135,270]) translate([-10,-2,2.5]) 
    linear_extrude(height = 11, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,135,270]) translate([-10,-4,2.5]) 
    linear_extrude(height = 11, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    
    rotate([0,0,180])
    translate([-3.6,-19.5,7]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,0,180])translate([-3.6,-17,7])  
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,0,180])translate([-3.6,-15,7]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,0,180])translate([-3.6,-13,7])  
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);} 
    rotate([0,0,180])translate([-3.6,-11,7]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);} 

    rotate([0,0,180])
    translate([-2.25,-19.5,7]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,0,180])translate([-2.25,-17,7])  
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,0,180])translate([-2.25,-15,7]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}
    rotate([0,0,180])translate([-2.25,-13,7])  
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);} 
    rotate([0,0,180])translate([-2.25,-11,7]) 
    linear_extrude(height = 10, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.5, $fn=10);}

}  
    
    
    
    
    
    
    
    
    module suport1(){


color("yellow") 
   
      rotate([0,0,0]) 
    union(){
    for(a= [22.5: 5: 158]){
   rotate([0,0,a])
    translate([24.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }

    for(a= [25: 5: 110]){
   rotate([0,0,a])
    translate([22.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    for(a= [125: 5: 158]){
   rotate([0,0,a])
    translate([22.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [27.5: 5: 110]){
   rotate([0,0,a])
    translate([20.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    for(a= [127.5: 5: 153]){
   rotate([0,0,a])
    translate([20.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [30.5: 7: 153]){
   rotate([0,0,a])
    translate([18.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [35: 6.5: 148]){
   rotate([0,0,a])
    translate([16.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [40.5: 7: 145]){
   rotate([0,0,a])
    translate([14.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [32.5: 7: 148]){
   rotate([0,0,a])
    translate([12.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    } 
    
}
color("yellow") 
   
      rotate([0,0,180]) 
    union(){
    for(a= [22.5: 5: 158]){
   rotate([0,0,a])
    translate([24.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }

    for(a= [25: 5: 158]){
   rotate([0,0,a])
    translate([22.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }

    
    for(a= [27.5: 5: 153]){
   rotate([0,0,a])
    translate([20.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }

    
    for(a= [30.5: 7: 153]){
   rotate([0,0,a])
    translate([18.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [35: 6.5: 148]){
   rotate([0,0,a])
    translate([16.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [40.5: 7: 145]){
   rotate([0,0,a])
    translate([14.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    for(a= [32.5: 7: 148]){
   rotate([0,0,a])
    translate([12.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    } 
    
}
color("yellow") 
union(){
    for(a= [0: 8: 360]){
   rotate([0,0,a])
    translate([10.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    for(a= [0: 10: 360]){
   rotate([0,0,a])
    translate([8.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    for(a= [0: 12: 360]){
   rotate([0,0,a])
    translate([6.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }  
    for(a= [0: 18: 360]){
   rotate([0,0,a])
    translate([4.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    for(a= [0: 36: 360]){
   rotate([0,0,a])
    translate([2.5,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    for(a= [0: 90: 360]){
   rotate([0,0,a])
    translate([1,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    
}
translate([-9.75,18.85,0])
color("red") 
union(){
    
    for(a= [0: 90: 360]){
   rotate([0,0,a])
    translate([0.65,0,-2]) 
    linear_extrude(height = 6, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    } 
    
}



}
    
    
    
    
    
    
    
    
    
    
    


union(){
    

translate([-15.5,10.5,9]) holea();
//translate([14,18,9]) holea();
//translate([-15.5,-17,9]) holea();
translate([16.5,-11.5,9]) holea();



translate([-15.5,-17,2]) rotate([0,0,217])screwholdb();
translate([14,18,2]) rotate([0,0,43])screwholdr();





translate([6,1.25,0])suport();
rotate ([0,0,180]) translate([6,1.25,0])suport();
    suport1();

rotate ([0,0,0]) translate([-9.8,18.8,0]) reset();








mirror([90,0,0]) translate([-5.75,3.25,7])motorholder();
rotate([0,0,180]) mirror([90,0,0]) translate([-5.75,3.25,7])motorholder();


translate([0,0,-4.52]) chassisbase();

difference(){
chassisboy();
motcut();



}



}
