$fs = 0.1;
$fa = 1;  



module holderMainRing() {
    
    difference()
    {
    color("Red") cylinder(h=2, r=26.5, center=true, $fn=100);
    color("White") cylinder(h=2.1, r=25.5, center=true, $fn=100);    
    }
    translate([0,0,-1.5])
    difference()
    {
    color("Blue") cylinder(h=1.5, r=26.5, center=true, $fn=100);
    color("White") cylinder(h=2, r=24, center=true, $fn=100);    
    }
    translate([0,0,-5])
    difference()
    {
    color("lime") cylinder(h=5.5, r=26.5, center=true, $fn=100);
    color("White") cylinder(h=6, r=18.5, center=true, $fn=100);    
    }

    
}
translate([0,0,1.4]) mainbase();
module mainbase(){
    
    difference(){
            color("Red") cylinder(h=0.8, r=27.5, center=true, $fn=100);
            color("White") cylinder(h=1.1, r=17, center=true, $fn=100);  
        
        
        }
    
    
    }
module sensorHole() {
    rotate([0,0,0])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,60])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,120])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,180])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,240])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,300])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    
}

module holecut() {
    rotate([0,0,45])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,105])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,165])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,225])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,285])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,345])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    
}







module holeai(){
color("pink")
    translate([0,0,3]) 
    linear_extrude(height = 6.5, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 1.35, $fn=200);}
    }
module holeao(){
color("red")
    translate([0,0,1]) 
    linear_extrude(height = 2, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}  
color("blue")
    translate([0,0,3]) 
    linear_extrude(height = 2, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}
color("blue")        translate([0,0,3]) 
    linear_extrude(height = 2, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}
color("blue")       translate([3,0,6]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}
    color("blue")
    translate([1.5,0,3]) 
    linear_extrude(height = 2, center = true, convexity = 10, twist = 0, $fn=200){
    polygon(points = [[-1.5,-2],[1.5,-2],[1.5,2],[-1.5,2],[-1.5,-2]]);}
    
    }

module holea(){
    difference() {
    holeao();
    holeai();
 color("red")
    translate([0,0,7.5]) 
    linear_extrude(height = 7, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2.1, $fn=200);}
    }
}



module suport1()
{
color("yellow") 
   
      rotate([0,0,0]) 
    union(){
   rotate([0,0,9.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,13.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-9.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,-13.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    ccircle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    ccircle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,12])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,0])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
    }    

}

module suport2()
{
color("yellow") 
   
      rotate([0,0,0]) 
    union(){
   rotate([0,0,9.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,13.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-9.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,-13.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    ccircle(r = 0.35, $fn=10);}
   rotate([0,0,12])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   rotate([0,0,4])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   rotate([0,0,12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
    }    

}

module suport3()
{
color("yellow") 
   
      rotate([0,0,0]) 
    union(){
   rotate([0,0,9.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    ccircle(r = 0.35, $fn=10);}
     rotate([0,0,13.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-9.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,-13.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    ccircle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   rotate([0,0,12])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   rotate([0,0,4])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   rotate([0,0,12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
    }    

}

module suport4()
{
color("yellow") 
      rotate([0,0,0]) 
    union(){
   rotate([0,0,8.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,11.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-9.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,-13.5])
    translate([24,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([24,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,0])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([22,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,11])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([22,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
     rotate([0,0,0])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,4])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-4])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-12])
    translate([19.5,0,-1.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
    }      

}
module suport5()
{
color("yellow") 
   
      rotate([0,0,0]) 
    union(){

   rotate([0,0,0])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
 
   rotate([0,0,0])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   
 
   rotate([0,0,0])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
        
   rotate([0,0,0])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
   circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}  
    
    
    
    
      }   
}
module suport6()
{
color("yellow") 
   
      rotate([0,0,0]) 
    union(){

   rotate([0,0,0])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
 
   rotate([0,0,0])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   
 
   rotate([0,0,0])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

    
   rotate([0,0,0])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);} 
    
    
    
    
      }   
}
module suport7()
{
color("yellow") 
   
      rotate([0,0,0]) 
    union(){

   rotate([0,0,0])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([25.75,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
 
   rotate([0,0,0])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}}

   rotate([0,0,10])
    translate([23.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   
 
   rotate([0,0,0])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}

   rotate([0,0,10])
    translate([21.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}


    
   rotate([0,0,0])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,5])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-5])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,10])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-10])
    translate([19.5,0,-3]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}  
    
    
    
    
      }   

module suport8(){
    
    

       rotate([0,165,0])
    translate([0,0,11])
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.45, $fn=10);}
    
    /*
     rotate([0,0,0])
    translate([17.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
   rotate([0,0,-8])
    translate([17.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
     rotate([0,0,-4])
    translate([21,0,-6.251]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
     rotate([0,0,-2.5])
    translate([19.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
     rotate([0,0,-7.5])
    translate([19.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
    rotate([0,0,-12])
    translate([24,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
 
 
    rotate([0,0,-10.5])
    translate([22.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
   rotate([0,0,-15])
    translate([22.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}    
    
       rotate([0,0,-6])
    translate([23.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    
   rotate([0,0,-10])
    translate([23.5,0,-6.25]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.35, $fn=10);}
    */
    }
    
 translate([6.5,19,0]) rotate([0,0,-45]) suport8();
  translate([10,20.75,0]) rotate([0,0,-90]) suport8();
    
 translate([22,-10.5,0]) rotate([0,0,-135]) suport8();    
translate([14,-18,0]) rotate([0,0,-315]) suport8(); 
    
  translate([-1.5,-1.5,0]) rotate([0,0,-180])   
    union(){
translate([6.5,19,0]) rotate([0,0,-45]) suport8();
  translate([10,20.75,0]) rotate([0,0,-90]) suport8();
    }
  translate([-35,30,0]) rotate([0,0,0])   
    union(){
 translate([22,-10.5,0]) rotate([0,0,-135]) suport8();    
translate([14,-18,0]) rotate([0,0,-315]) suport8();
    }
    
rotate([0,0,150]) suport6();
rotate([0,0,330]) suport7();
suport1();
rotate([0,0,30]) suport5();
rotate([0,0,90]) suport5();
rotate([0,0,210]) suport5();
rotate([0,0,270]) suport5();
rotate([0,0,180]) suport1();
rotate([0,0,300]) suport1();

rotate([0,0,60])suport2();
rotate([0,0,240])suport3();
rotate([0,0,120])suport4();


difference(){
holderMainRing();
holecut();

sensorHole();
    color("red")
    translate([10.5,15.5,-6]) 
    linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2.1, $fn=200);}
    
    color("red")
    translate([18,-14,-5]) 
    linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2.1, $fn=200);}
    
    color("red")
    translate([-17,15.5,-4]) 
    linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2.1, $fn=200);}
 
    color("red")
    translate([-11.5,-16.5,-5]) 
    linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2.1, $fn=200);}
}








translate([10.5,15.5,-17.5]) rotate([0,0,360])  holea();
translate([18,-14,-17.5])  rotate([0,0,140]) holea();
translate([-17,15.5,-17.5]) rotate([0,0,320]) holea();
translate([-11.5,-16.5,-17.5]) rotate([0,0,180])holea();


















































