$fs = 0.1;
$fa = 1;  












module decodePolygon() {
    difference() {/*2.2744*/
        translate([0,0,-0.5]) polygon( points=[[0,0],[8,0],[8,2.599],[0,0]] );
        translate([0,0,-0.5]) polygon( points=[[0,-1],[3,0],[3,3],[0,3],[0,0]] );
    }
}

module decodePart() {
    linear_extrude(height = 3.5, center = true, convexity = 10, twist = 0, $fn=100) decodePolygon();
}

//rotate([0,0,0]) decodePart();
//rotate([0,0,36]) decodePart();


module decodePartDiff() {

rotate([0,0,0]) decodePart();
rotate([0,0,36]) decodePart();
rotate([0,0,72]) decodePart();
rotate([0,0,108]) decodePart();
rotate([0,0,144]) decodePart();
rotate([0,0,180]) decodePart();
rotate([0,0,216]) decodePart();
rotate([0,0,252]) decodePart();
rotate([0,0,288]) decodePart();
rotate([0,0,324]) decodePart();

}







   module decodeOut() {
       
       color("Teal") cylinder(h=3.5, r=7.5, center=true, $fn=100);
       
       }



       module decodeIn() {
           
       color("Purple") cylinder(h=3.5, r=6.25, center=true, $fn=100);
           
           }
   module decodeOutIn(){    
           difference() {
       decodeOut();
        decodeIn();
           }
       }




module wheelBody() {
    color("Lime") cylinder(h=4, r=8, center=true, $fn=200);
}







module decode(){
    translate([0,0,3.5])
    difference() {
    decodeOutIn();
    decodePartDiff();
    } 
}






//decode();
//wheelBody();






module drivehole() {
    intersection() {
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=100)
    color("red") polygon( points=[[1.5,1.25],[1.5,-1.25],[-1.5,-1.25],[-1.5,1.25],[1.5,1.25]] );
    color("red") cylinder(h=5, r=1.5, center=true, $fn=200);
    //color("orange") square ([2,2],center = true);
    }
}



module xy() {
    difference() {
wheelBody();
drivehole();

    }
}

xy();
decode();

translate([0,0,-2.25]) color("red") cylinder(h=0.5, r=9, center=true, $fn=200);






