/*
 * GccApplication11.c
 *
 * Created: 17.08.2014 15:25:10
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 8000000UL

#include <util/delay.h>

volatile uint16_t rc5Command =        0b00000000000000;
uint16_t rc5Code =           0b00000000000000;

volatile uint16_t rc5CommandBits =       0x2000;	
uint16_t rc5CodeBits =          0x20;

uint8_t rc5CodeMSB =		5;
uint8_t rc5CodeLSB =		0;

volatile struct {
	
	uint8_t rc5StartBit :	0b1;
	uint8_t rc5FieldBit :	0b1;
	uint8_t rc5ToggleBit :	0b1;
	uint8_t rc5AddressBit : 0b00101;
	uint8_t rc5CodeBit :	0b000110;
	
	
	} rc5Command; 



int main(void)
{
	DDRD &= ~(1 << PD2);
	DDRD |= (1 << PD6);
	
	PORTD |= (1 << PORTD2) | (1 << PD6);
	
	DDRB |= (1 << PB1) | (1 << PB2);
	PORTB |= (1 << PB1) | (1 << PB2);

	
	
	//TCCR0A |= (1 << WGM01);
  
	
  
	//OCR0A = 111-1;
  
	//TIMSK0 |= (1<<OCIE0A);
	
	
	EICRA |= (1 << ISC00);
	  
	EIMSK |= (1 << INT0);
	
	//TCCR0B |= (1 << CS00); 
	  
	//TIMSK0 |= (1 << TOIE0);
	
	sei();
	  
    while(1)
    {
		if (rc5Command & 0x3F)
		{//PORTD ^= (1 << PD6);
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x3E)
		{	PORTD |= (1 << PD6);
			PORTB |= (1 << PB1);
			PORTB &= ~(1 << PB2);
			rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
				
	    if (rc5Command & 0x3D)
		{	
			PORTB |= ((1 << PB1) | (1 << PB2));
			PORTD &= ~(1 << PD6);
			rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}	
			
		if (rc5Command & 0x3C)
		{   PORTD ^= (1 << PD6);
			PORTB |= (1 << PB2);
			PORTB &= ~(1 << PB1);
			rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x3B)
		{//PORTB ^= (1 << PB1);
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x3A)
		{
			//PORTB ^= (1 << PB2);
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}					
		if (rc5Command & 0x39)
		{//PORTD ^= (1 << PD6);
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x38)
		{//PORTB ^= (1 << PB1);
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x37)
		{
			//PORTB ^= (1 << PB2);
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}				
		
        //TODO:: Please write your application code 
    }
}
volatile uint8_t interruptExt = 0;///////////////////
uint8_t compareMatchCounterHigh = 0;
uint8_t compareMatchCounterLow = 0;

uint16_t rc5CommandLength = 0b10000000000000;

volatile uint8_t rc5HalfbitTimeAvaible = 0;
volatile uint8_t rc5HalfbitTime = 0;
volatile uint8_t rc5HalfbitTimeUndWenig = 0;

volatile uint8_t rc5HalfbitTimex = 0;
volatile uint8_t rc5HalfbitTimeUndWenigx = 0;
volatile uint8_t rc5HalfbitTimey = 0;
volatile uint8_t rc5HalfbitTimeUndWenigy = 0;

volatile uint8_t rc5HalfbitTransmition = 0;
volatile uint8_t rc5LastReadBit = 0;
volatile uint8_t y = 0;
volatile uint8_t rc5HalfbitTransmitionx = 0;
volatile uint16_t rc5CommandArray[3] = {0};
	
	
ISR(INT0_vect)
{		
		TIMSK0 &= ~(1 << TOIE0);
		TCCR0B &= ~(1 << CS01);
		
		
		if(rc5HalfbitTimeAvaible == 0 && interruptExt == 1)
		{
			
			rc5HalfbitTimeUndWenig = TCNT0;
			rc5HalfbitTransmition = (rc5HalfbitTime * 256) + rc5HalfbitTimeUndWenig;
			rc5HalfbitTimeAvaible = 1;
			rc5Command |= ((uint16_t)1 << rc5CommandBits);
			rc5LastReadBit = 1;
			rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			//rc5HalfbitTimeUndWenigx = 0;
		}
		
		rc5HalfbitTimeUndWenigx = TCNT0;		
		rc5HalfbitTransmitionx = (rc5HalfbitTimex * 256) + rc5HalfbitTimeUndWenigx;

		TCNT0 = 0;
		rc5HalfbitTime = 0;
		rc5HalfbitTimex = 0;
		TCCR0B |= (1 << CS01);
		TIMSK0 |= (1 << TOIE0);
		
	    
	
		if(!(rc5Command & rc5CommandBits) && rc5HalfbitTimeAvaible == 1 && interruptExt >= 2)
		{
			if(rc5LastReadBit == 1 && rc5HalfbitTransmition <= rc5HalfbitTransmitionx)
			{

				rc5Command |= ((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 1;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
			
			else if(rc5LastReadBit == 1 && rc5HalfbitTransmition >= rc5HalfbitTransmitionx)
			{
				rc5Command &= ~((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 0;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
			
			else if(rc5LastReadBit == 0 && rc5HalfbitTransmition <= rc5HalfbitTransmitionx)
			{
				rc5Command &= ~((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 0;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
			
			else if(rc5LastReadBit == 0 && rc5HalfbitTransmition >= rc5HalfbitTransmitionx)
			{
				rc5Command |= ((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 1;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
	
		}	
/*
	if(rc5Command & 0x3000)
	{
		
		rc5CommandBits = 0b10000000000000;
		interruptExt = 0;
		rc5Command = 0b00000000000000;
		rc5HalfbitTimeAvaible = 0;
		//rc5CommandSent = 0;
	}
	*/
	
	if(rc5CommandBits & 0x1)
	{
			//PORTD ^= (1 << PD6);
		rc5CommandBits = 0x2000;
		interruptExt = 0;
		//rc5Command = (rc5Command >> (uint16_t)1);
		rc5HalfbitTimeAvaible = 0;
		//rc5CommandSent = 0;
	}	
	
	
	interruptExt++;
}

ISR(TIMER0_OVF_vect)
{
	
	rc5HalfbitTime++;
	rc5HalfbitTimex++;
	
	
}