/*
 * GccApplication11.c
 *
 * Created: 17.08.2014 15:25:10
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 8000000UL

#include <util/delay.h>

volatile uint16_t rc5Command =        0b00000000000000;
uint16_t rc5Code =           0b00000000000000;

volatile uint16_t rc5CommandBits =       0x4000;	
uint16_t rc5CodeBits =          0x20;

uint8_t rc5CodeMSB =		5;
uint8_t rc5CodeLSB =		0;

/*
volatile struct {
	
	uint8_t rc5StartBit :	0b1;
	uint8_t rc5FieldBit :	0b1;
	uint8_t rc5ToggleBit :	0b1;
	uint8_t rc5AddressBit : 0b00101;
	uint8_t rc5CodeBit :	0b000110;
	
	
	} rc5Command; 

*/

uint8_t xy = 0;
int main(void)
{
	DDRD &= ~(1 << PD2);
	DDRD |= (1 << PD6);
	
	PORTD |= (1 << PORTD2) | (1 << PD6);
	
	DDRB |= (1 << PB1) | (1 << PB2);
	PORTB |= (1 << PB1) | (1 << PB2);

	
	
	//TCCR0A |= (1 << WGM01);
  
	
  
	//OCR0A = 111-1;
  
	//TIMSK0 |= (1<<OCIE0A);
	
	
	EICRA |= (1 << ISC00);
	  
	EIMSK |= (1 << INT0);
	
	TCCR0B |= (1 << CS02) | (1 << CS00);
	  
	//TIMSK0 |= (1 << TOIE0);
	//TIMSK0 |= (1 << TOIE0);
	sei();
	  
    while(1)
    {
		xy++;
		
		if (xy == 14)
		{
			PORTD ^= (1 << PD6);
			xy = 0;
			
			ISR(INT0_vect);
		}

    }
}

volatile uint8_t interruptExt = 0;///////////////////
uint8_t compareMatchCounterHigh = 0;
uint8_t compareMatchCounterLow = 0;

uint16_t rc5CommandLength = 0b10000000000000;

volatile uint8_t rc5HalfbitTimeAvaible = 0;
volatile uint8_t rc5HalfbitTime = 0;
volatile uint8_t rc5HalfbitTimeUndWenig = 0;

volatile uint8_t rc5HalfbitTimex = 0;
volatile uint8_t rc5HalfbitTimeUndWenigx = 0;
volatile uint8_t rc5HalfbitTimey = 0;
volatile uint8_t rc5HalfbitTimeUndWenigy = 0;

volatile uint8_t rc5HalfbitTransmition = 0;
volatile uint8_t rc5LastReadBit = 0;
volatile uint8_t y = 0;
volatile uint8_t rc5HalfbitTransmitionx = 0;
volatile uint16_t rc5CommandArray[3] = {0};
volatile uint8_t tcnt0 = 0; 
volatile uint8_t rc5DataTime = 0; 
	
ISR(INT0_vect)
{	
	
	// TCCR0B &= ~((1 << CS02) | (1 << CS01) | (1 << CS00));
	
	TIMSK0 &= ~(1 << TOIE0);
	TCCR0B &= ~((1 << CS02) | (1 << CS01) | (1 << CS00));
	
	if(rc5HalfbitTimeAvaible == 0 && interruptExt == 1)
	{
	
		tcnt0 = TCNT0;
		rc5HalfbitTransmition = 256 - tcnt0;
		TCNT0 = 249;
		rc5HalfbitTimeAvaible = 1;
		rc5Command |= ((uint16_t)1 << rc5CommandBits);
		rc5LastReadBit = 1;xy++;
		rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
		
	}


	//TCCR0B |= ((1 << CS02) | (1 << CS00));
	TCCR0B |= ((1 << CS02) | (1 << CS00)); 
	TIMSK0 |= (1 << TOIE0);

	if(rc5HalfbitTimeAvaible == 1 && rc5DataTime == 1 && interruptExt >= 2)
	{
				
		if(rc5LastReadBit == 1)
		{//rc5DataTime = 0;
			//PORTB ^= (1 << PB2);
			rc5Command |= ((uint16_t)1 << rc5CommandBits);
			rc5LastReadBit = 1;xy++;
			rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
		}
		
		else if(rc5LastReadBit == 0)
		{//rc5DataTime = 0;
			//PORTB ^= (1 << PB2);
			rc5Command &= ~((uint16_t)1 << rc5CommandBits);
			rc5LastReadBit = 0;xy++;
			rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
		}
		
	}
	
	if(rc5HalfbitTimeAvaible == 1 && rc5DataTime == 2)
	{
		
		if(rc5LastReadBit == 1)
		{   //PORTD ^= (1 << PD6);
			rc5Command &= ~((uint16_t)1 << rc5CommandBits);
			rc5LastReadBit = 0;xy++;
			rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
		}

		else if(rc5LastReadBit == 0)
		{	//PORTD ^= (1 << PD6);
			rc5Command |= ((uint16_t)1 << rc5CommandBits);
			rc5LastReadBit = 1;xy++;
			rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
		}
		
	}
	const char a = a;
	printf_P(a);
	if(rc5CommandBits & 0x1)
	{PORTB ^= (1 << PB1);
		rc5CommandBits = 0x4000;
		 rc5Command = (rc5Command >> (uint16_t)1);
		 rc5Command = 0x0;
		interruptExt = 0;
		rc5HalfbitTimeAvaible = 0;
		//TIMSK0 &= ~(1 << TOIE0);
	}

	interruptExt++;

}


volatile uint8_t count = 0;


ISR(TIMER0_OVF_vect)
{	PORTB ^= (1 << PB2);
	
		if(rc5DataTime == 2)
		{
			rc5DataTime = 0;
		}
		
	    if(rc5DataTime < 2)
		{
			rc5DataTime++;
		}
		
		TCNT0 = 249;
		
	}
