/*
 * GccApplication21.c
 *
 * Created: 01.02.2015 16:45:20
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <util/twi.h>


#define TW_START 0x08
#define TW_REPEATED_START 0x10
#define TW_MT_SLA_ACK 0x18
#define TW_MT_SLA_NACK 0x20
#define TW_MT_DATA_ACK 0x28
#define TW_MT_DATA_NACK 0x30
#define TW_MT_ARBITRATION 0x28



int main(void)
{

	
	
    while(1)
    {
        //TODO:: Please write your application code 
    }
}




void compass_init(void) {
	
	#define CP_SLA_W 0x3C
	#define CP_SLA_R 0x3D

}





void twi_init(void) {
	
	DDRD |= (1 << PORTD7) | (1 << PORTD4);
		
	TWCR = (1 << TWINT) | (1 << TWSTA) | (1 << TWEN);
	
	while  (!(TWCR & (1<<TWINT)));
		if ((TWSR & 0xF8) != TW_START)
		ERROR();
		TWDR = CP_SLA_W;
		TWCR = (1<<TWINT) | (1<<TWEN);
	
	
	while (!(TWCR & (1<<TWINT)));
		if ((TWSR & 0xF8) != TW_MT_SLA_ACK)
		ERROR();
		TWDR = DATA;
		TWCR = (1<<TWINT) | (1<<TWEN);
	
	
	while (!(TWCR & (1<<TWINT)));
		if ((TWSR & 0xF8) != TW_MT_DATA_ACK)
		ERROR();
		TWCR = (1<<TWINT) | (1<<TWEN) | (1<<TWSTO);
}


























void ExtInt_init(void) {
	
	
}


void adc_init(void) {
	
	ADMUX = (1 << REFS0);
	
	ADCSRA = (1 << ADPS1) | (1 << ADPS0);
	ADCSRA = (1 << ADEN);
	
	ADCSRA |= (1 << ADSC);
	while(ADCSRA & (1 << ADSC)) {
	}
	
	(void)ADCW;
	
}

uint16_t ADC_Read(uint8_t channel) {
	ADMUX = (ADMUX & ~(0x1F)) | (channel & 0x1F);
	ADCSRA |= (1<<ADSC);
	while (ADCSRA & (1<<ADSC)) {
	}
	return ADCW;
}