/*
 * GccApplication27.cpp
 *
 * Created: 15.03.2015 10:54:44
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <math.h>
#define F_CPU 8000000UL
#include <avr/interrupt.h>
#include "Adafruit_TCS34725.h"


volatile unsigned long millisekunden;

Adafruit_TCS34725 tcs;

int main(void)
{
	TCCR0A = (1<<WGM01);
	TCCR0B = (1<<CS01) | (1<<CS01);
	OCR0A = 125-1;
	TIMSK0 |= (1<<OCIE0A);
	
	sei();
	
	
	Adafruit_TCS34725 tcs = Adafruit_TCS34725(TCS34725_INTEGRATIONTIME_700MS, TCS34725_GAIN_1X);
// 	tcs.setIntegrationTime(TCS34725_INTEGRATIONTIME_2_4MS);
// 	tcs.setGain(TCS34725_GAIN_1X);
	
	if (tcs.begin())
	{
		//
	}
	
	
    while(1)
    {
		uint16_t r, g, b, c, colorTemp, lux;
		tcs.getRawData(&r, &g, &b, &c);
		colorTemp = tcs.calculateColorTemperature(r, g, b);
		lux = tcs.calculateLux(r, g, b);	
        //TODO:: Please write your application code 
    }
}








ISR(TIMER0_COMPA_vect)
{
	++millisekunden;
}

unsigned long millis(void)
{
	return millisekunden;
}
