/*
 * GccApplication3.c
 *
 * Created: 19.05.2014 22:17:06
 *  Author: Fabio
 */ 
#define F_CPU 16000000UL


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

double dutyCycleRed = 100;
double dutyCycleGreen = 100;
double dutyCycleBlue = 100;


int main(void)
{
	// PB1 as PWM output for blue led
	// PB2 as PWM output for red led
	DDRB = (1 << DDB1) | (1 << DDB2);

	// PD6 as PWM output for green led
	DDRD = (1 << DDD6);


	TCCR0A = (1 << COM0A1) | (0 << COM0A0) | (1 << COM0B1) | (0 << COM0B0) | (1 << WGM01) | (1 << WGM00);

	TIMSK0 = (1 << TOIE0);
	TIFR0 = (1 << TOV0);

	TCCR1A = (1 << COM1A1) | (0 << COM1A0) | (1 << COM1B1) | (0 << COM1B0) | (1 << WGM11) | (0 << WGM10);

	TIMSK1 = (1 << TOIE1);
	TIFR1 = (1 << TOV1);




	sei();

	TCCR0B = (0 << CS02) | (0 << CS01) | (1 << CS00);

	TCCR1B = (1 << WGM12) | (0 << CS12) | (0 << CS11) | (1 << CS10);




	while(1)
	{
		OCR1B = (dutyCycleRed/100)*255;

		OCR1A = (dutyCycleGreen/100)*255;
		
		OCR0A = (dutyCycleBlue/100)*255;
		_delay_ms(100);
		
		dutyCycleRed += 5;
		dutyCycleGreen += 5;
		dutyCycleBlue += 5;

	}
}


ISR(TIMER0_OVF_vect)
{	OCR1B = (dutyCycleRed/100)*255;

	OCR1A = (dutyCycleGreen/100)*255;
	
	OCR0A = (dutyCycleBlue/100)*255;
	_delay_ms(100);
	
	dutyCycleRed += 5;
	dutyCycleGreen += 5;
	dutyCycleBlue += 5;
}


ISR(TIMER1_OVF_vect)
{	OCR1B = (dutyCycleRed/100)*255;

	OCR1A = (dutyCycleGreen/100)*255;
	
	OCR0A = (dutyCycleBlue/100)*255;
	_delay_ms(100);
	
	dutyCycleRed += 5;
	dutyCycleGreen += 5;
	dutyCycleBlue += 5;


}