/*
 * GccApplication6.c
 *
 * Created: 29.05.2014 16:37:04
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>

#define F_CPU 16000000

#include <util/delay.h>

//#define F_CPU 10000000UL

double dutyCycleRed = 0;
double dutyCycleGreen = 0;
double dutyCycleBlue = 0;


int main(void)
{  // PB1 as PWM output for blue led
	// PB2 as PWM output for red led
		DDRB = (1 << PORTB1) | (1 << PORTB2);
		// PD6 as PWM output for green led
		DDRD = (1 << PORTD6);
	        
		TCCR0A = (1 << COM0A1) | (1 << WGM00) | (1 << WGM01);
		TCCR1A = (1 << COM1A1) | (1 << COM1B1) | (1 << WGM10);
		
		TIMSK0 = (1 << TOIE0);
	    TIMSK1 = (1 << TOIE1);
		    
		sei();
				
		TCCR0B = (1 << CS00);
		TCCR1B = (1 << CS10) | (1 << WGM12);
		
		
			
    while(1)
    {
		_delay_us(1);
		dutyCycleRed += 3;
		dutyCycleGreen += 3;
		dutyCycleBlue += 3;
		if(dutyCycleRed > 100)
		{
			dutyCycleRed = 0;
		}
		if(dutyCycleGreen > 100)
		{
		    dutyCycleGreen = 0;
		}
		if(dutyCycleBlue > 100)
		{
		    dutyCycleBlue = 0;
		}
    }
}

ISR(TIMER0_OVF_vect)
{	
	OCR0A = 200;
}

ISR(TIMER1_OVF_vect)
{
	OCR1AH = 0x00;
	OCR1AL = 200;
	OCR1BH = 0x00;
	OCR1BL = 255;
}



