/*
 * IrCommDatabaseManegment.cpp
 *
 * Created: 30.08.2015 21:55:38
 *  Author: Fabio
 */ 
#include <string.h>

#include "IrCommDatabaseManegment.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\IrComm\DatabaseManegmentFlags.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\IrComm\IrComm.h"
#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotStatusLightHardwareControl\StatusLight\StatusLight.h"



DatabaseManegmentFlags dmf;
StatusLight l;
uint8_t IrCommDatabaseManegment::newData_TX[12] = {0};
uint8_t IrCommDatabaseManegment::newData_RX[12] = {0};

// volatile uint32_t IrCommDatabaseManegment::DataAndRule_TX = 0;
// volatile uint32_t IrCommDatabaseManegment::DataAndRule_RX = 0;
volatile int IrCommDatabaseManegment::numberOfRequestedData = 0;
volatile int IrCommDatabaseManegment::numberOfRequestedRule = 0;


uint8_t newDataAndRule_TX[3] = {0};
uint8_t newDataAndRule_RX[3] = {0};

uint8_t irCommDataFrame_TX[16] = {0};
uint8_t irCommDataFrame_RX[16] = {0};
	
IrCommDatabaseManegment::IrCommDatabaseManegment(){}
	


void IrCommDatabaseManegment::putNewDataIntoDatabase()
{
// 	if (dmf.checkDatabaseFlag_TX())
// 	{
		//l.setStatusLightOk();
		if (dmf.checkTargetDatabaseFlag_TX())
		{
			
			/*	extern function get target	*/
			memcpy(newData_TX, colorDataArray, sizeof(externIrCommRc5Data));
			dmf.clearTargetDatabaseFlag_TX();
		}
		else if (dmf.checkEnvironmentDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x10000;
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearEnvironmentDatabaseFlag_TX();
		}
		else if (dmf.checkCoordinatesDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x8000;
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCoordinatesDatabaseFlag_TX();
		}
		else if (dmf.checkPositionDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x4000;
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearPositionDatabaseFlag_TX();
		}
		else if (dmf.checkLightDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x2000;
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearLightDatabaseFlag_TX();
		}
		else if (dmf.checkColorDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x1000;
			externColorData();
			for (int i = 0; i < 12; i++)
			{
				newData_TX[i] = colorDataArray[i];
			}
			
			/*memcpy(newData_TX, colorDataArray, sizeof(colorDataArray));*/
			dmf.clearColorDatabaseFlag_TX();
		}
		else if (dmf.checkSpeedDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x800;
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearSpeedDatabaseFlag_TX();
		}
		else if (dmf.checkCompassDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x400;
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCompassDatabaseFlag_TX();
		}
		else if (dmf.checkReserveDatabaseFlag_TX())
		{
			//DataAndRule_TX |= 0x200;
			memcpy(newData_TX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearReserveDatabaseFlag_TX();
		}
/*	}*/
}


void IrCommDatabaseManegment::convertDatabaseToRc5Command()
{
	uint64_t irCommData_00 = 0b0;
	uint32_t irCommData_01 = 0b0;
	
	uint64_t irCommDataMask64 = 0xFF;
	uint32_t irCommDataMask32 = 0xFF;
	
	int irComm64 = 0;
	int irComm32 = 0;
	int irCommBitShift = 8;
	
	for (int i = 0; i < 8; i++)
	{
		irCommData_00 |= ((newData_TX[i] & irCommDataMask64) << irComm64);
		irComm64 += irCommBitShift;
	}
	
	for (int i = 8; i < 12; i++)
	{
		irCommData_01 |= ((newData_TX[i] & irCommDataMask32) << irComm32);
		irComm32 += irCommBitShift;
	}
	
	
	irCommDataMask64 = 0x3F;
	irCommDataMask32 = 0xFC;
	
	irComm64 = 0;
	irComm32 = 2;
	irCommBitShift = 6;
	
	for(int i = 0; i < 10; i++)
	{
		irCommDataFrame_TX[i] = ((irCommData_00 & irCommDataMask64) >> irComm64);
		irCommDataMask64 = (irCommDataMask64 << irCommBitShift);
		irComm64 += irCommBitShift;
	}
	
	uint8_t bitsOf64 = ((irCommData_00 & 0xF000000000000000) >> 60);
	uint8_t bitsOf32 = ((irCommData_01 & 0x3) << 4);
	
	irCommDataFrame_TX[10] = bitsOf32 | bitsOf64;
	
	for(int i = 11; i < 16; i++)
	{
		irCommDataFrame_TX[i] = ((irCommData_01 & irCommDataMask32) >> irComm32);
		irCommDataMask32 = (irCommDataMask32 << irCommBitShift);
		irComm32 += irCommBitShift;
	}
}




void IrCommDatabaseManegment::putReceivedIRDataIntoDatabase()
{
	if (dmf.checkDatabaseFlag_RX())
	{
		if (dmf.checkTargetDatabaseFlag_RX())
		{
			/*	extern function get target	*/
			memcpy(newData_RX, colorDataArray, sizeof(externIrCommRc5Data));
			dmf.clearTargetDatabaseFlag_RX();
		}
		else if (dmf.checkEnvironmentDatabaseFlag_RX())
		{
			
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearEnvironmentDatabaseFlag_RX();
		}
		else if (dmf.checkCoordinatesDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCoordinatesDatabaseFlag_RX();
		}
		else if (dmf.checkPositionDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearPositionDatabaseFlag_RX();
		}
		else if (dmf.checkLightDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearLightDatabaseFlag_RX();
		}
		else if (dmf.checkColorDatabaseFlag_RX())
		{
			/*irmp RX externColorData();*/
			memcpy(newData_RX, colorDataArray, sizeof(colorDataArray));
			dmf.clearColorDatabaseFlag_RX();
		}
		else if (dmf.checkSpeedDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearSpeedDatabaseFlag_RX();
		}
		else if (dmf.checkCompassDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearCompassDatabaseFlag_RX();
		}
		else if (dmf.checkReserveDatabaseFlag_RX())
		{
			memcpy(newData_RX, externIrCommRc5Data, sizeof(externIrCommRc5Data));
			dmf.clearReserveDatabaseFlag_RX();
		}
	}
}






void IrCommDatabaseManegment::clearDatabase()
{
// IRMP_DATA   irmp_data;
// uint8_t cvb = irmp_get_data (IRMP_DATA * addr_t);

}



void IrCommDatabaseManegment::convertRc5CommandToDatabase()
{
	uint64_t irCommData_00 = 0b0;
	uint32_t irCommData_01 = 0b0;	
	
	uint64_t irCommDataMask = 0x3F;

	
	int irComm64 = 0;
	int irComm32 = 2;
	int irCommBitShift = 6;
	
	for(int i = 0; i < 10; i++)
	{
		irCommData_00 |= ((irCommDataFrame_RX[i] & irCommDataMask) << irComm64);
		irComm64 += irCommBitShift;
	}
	
	irCommData_00 |= ((irCommDataFrame_RX[10] & 0xF) << 60);
	irCommData_01 |= ((irCommDataFrame_RX[10] & 0x30) >> 4);
	
	for(int i = 11; i < 16; i++)
	{
		irCommData_01 |= ((irCommDataFrame_RX[i] & irCommDataMask) << irComm32);
		irComm32 += irCommBitShift;
	}

	irCommDataMask = 0xFF;
	
	irComm64 = 0;
	irComm32 = 0;
	irCommBitShift = 8;
	
	for (int i = 0; i < 8; i++)
	{
		newData_RX[i] = ((irCommData_00 & irCommDataMask) << irComm64);
		irComm64 += irCommBitShift;
	}
	
	for (int i = 8; i < 12; i++)
	{
		newData_RX[i] = ((irCommData_01 & irCommDataMask) << irComm32);
		irComm32 += irCommBitShift;
	}
}

	



void IrCommDatabaseManegment::convertDataAndRuleToRc5Command()
{
	uint32_t irCommDataAndRuleMask = 0x3F;
	
	int irComm32 = 0;
	int irCommBitShift = 6;
	
	for (int i = 0; i < 3; i++)
	{
		newDataAndRule_TX[i] = ((dmf.DataAndRuleFlags_TX & irCommDataAndRuleMask) >> irComm32);
		irCommDataAndRuleMask = (irCommDataAndRuleMask << irCommBitShift);
		irComm32 += irCommBitShift;
	}
}


void IrCommDatabaseManegment::convertRc5CommandToDataAndRule()
{
	uint32_t irCommDataAndRuleMask = 0x3F;
	
	int irComm32 = 0;
	int irCommBitShift = 6;
	
	for (int i = 0; i < 3; i++)
	{
		dmf.DataAndRuleFlags_RX |= ((newDataAndRule_RX[i] & irCommDataAndRuleMask) << irComm32);
		irComm32 += irCommBitShift;
	}
}











void IrCommDatabaseManegment::perpareIncomingData()
{
	uint16_t splitData_TX = 0;
	uint16_t splitRule_TX = 0;
	
	convertRc5CommandToDataAndRule();
	
	splitData_TX = ((dmf.DataAndRuleFlags_TX & 0x3FE00) >> 9);
	splitRule_TX = (dmf.DataAndRuleFlags_TX & 0x1FF);
	
	if ((splitData_TX & COL_DATA) /*&& (splitRule_TX & COL_RULE)*/)
	{
		numberOfRequestedData++;
		dmf.setPositionDatabaseFlag_RX();
	}

}


void IrCommDatabaseManegment::perpareRequestedData()
{
	uint16_t splitData_TX = 0;
	uint16_t splitRule_TX = 0;
	uint16_t splitData_RX = 0;
	uint16_t splitRule_RX = 0;
	

	splitData_RX = ((dmf.DataAndRuleFlags_RX & 0x3FE00) >> 9);
	splitRule_RX = (dmf.DataAndRuleFlags_RX & 0x1FF);
	
	
	
	if ((splitData_RX & COL_DATA) /*&& (splitRule_RX & COL_RULE)*/)
	{
		numberOfRequestedData++;
		dmf.setDatabaseIsntEmptyFlag_TX();
		
		if ((splitRule_TX & POS_RULE) && (splitData_TX & POS_DATA) && (splitData_TX & COL_DATA))
		{
			numberOfRequestedData++;
			dmf.setPositionDatabaseFlag_TX();
		}
	}
	
	
// 	if ((splitData_TX & 0x80) == (splitData_RX & 0x80))
// 	{
// 		numberOfRequestedData++;
// 	}
// 	if ((splitData_TX & 0x40) == (splitData_RX & 0x40))
// 	{
// 		numberOfRequestedData++;
// 	}
// 	if ((splitData_TX & 0x20) == (splitData_RX & 0x20))
// 	{
// 		numberOfRequestedData++;
// 	}
// 	if ((splitData_TX & 0x10) == (splitData_RX & 0x10))
// 	{
// 		numberOfRequestedData++;
// 	}
// 	if ((splitData_TX & 0x8) == (splitData_RX & 0x8))
// 	{
// 		numberOfRequestedData++;
// 	}
// 	if ((splitData_TX & 0x4) == (splitData_RX & 0x4))
// 	{
// 		numberOfRequestedData++;
// 		dmf.setColorDatabaseFlag_RX();
// 	}
// 	if ((splitData_TX & 0x2) == (splitData_RX & 0x2))
// 	{
// 		numberOfRequestedData++;
// 	}
// 	if ((splitData_TX & 0x1) == (splitData_RX & 0x1))
// 	{
// 		numberOfRequestedData++;
// 	}
// 	
// 	
// 	
// 	
// 	if ((splitRule_TX & 0x80) == (splitRule_RX & 0x80))
// 	{
// 		numberOfRequestedRule++;
// 	}
// 	if ((splitRule_TX & 0x40) == (splitRule_RX & 0x40))
// 	{
// 		numberOfRequestedRule++;
// 	}
// 	if ((splitRule_TX & 0x20) == (splitRule_RX & 0x20))
// 	{
// 		numberOfRequestedRule++;
// 	}
// 	if ((splitRule_TX & 0x10) == (splitRule_RX & 0x10))
// 	{
// 		numberOfRequestedRule++;
// 	}
// 	if ((splitRule_TX & 0x8) == (splitRule_RX & 0x8))
// 	{
// 		numberOfRequestedRule++;
// 	}
// 	if ((splitRule_TX & 0x4) == (splitRule_RX & 0x4))
// 	{
// 		numberOfRequestedRule++;
// 	}
// 	if ((splitRule_TX & 0x2) == (splitRule_RX & 0x2))
// 	{
// 		numberOfRequestedRule++;
// 	}
// 	if ((splitRule_TX & 0x1) == (splitRule_RX & 0x1))
// 	{
// 		numberOfRequestedRule++;
// 	}
	
}












/*
	
void DatabaseManegmentFlags::initialize();*/


/*

	bool IrCommDatabaseManegment::DatabaseManegmentFlags::checkDatabaseFlag_TX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::setDatabaseFlag_TX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::getDatabaseFlag_TX();
	bool IrCommDatabaseManegment::DatabaseManegmentFlags::checkDatabaseFlag_RX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::setDatabaseFlag_RX();
	void IrCommDatabaseManegment::DatabaseManegmentFlags::getDatabaseFlag_RX();	
	*/
	
	