/*
 * IrCommHardwareControl.cpp
 *
 * Created: 11.08.2015 16:43:22
 *  Author: Fabio
 */ 

#include "IrCommHardwareControl.h"
#include <avr/interrupt.h>
//#include "C:\Users\Fabio\Documents\Atmel Studio\6.2\Robot Main v0.1\RobotMain\srcMain\specificLibMain\RobotIrCommHardwareControl\Irmp\irmp.h"

/*newDataAvailableFlags_t _newDataAvailableFlags.newColorDataAvailable = 0;*/


IrCommandHardwareControl::IrCommandHardwareControl(){}



//irmp_init();


void IrCommandHardwareControl::initialize()
{
	setIrLedFrontMiddleOutput();
	setIrLedFrontRightOutput();
	setIrLedBackRightOutput();
	setIrLedBackMiddleOutput();
	setIrLedBackLeftOutput();
	setIrLedFrontLeftOutput();
	
	setTimer0Config();
	setTimer0Off();
	setTimer0CompareMatchIntOff();
}


uint8_t IrCommandHardwareControl::getInitializeHardwareState()
{
	
}
uint8_t IrCommandHardwareControl::getSoftwareHardwareSate()
{
	
}



uint8_t IrCommandHardwareControl::getIrLedFrontMiddleOutput()
{
	
}
void IrCommandHardwareControl::setIrLedFrontMiddleOutput()
{
	IR_LED_FRONT_MIDDLE_OUTPUT;
}
uint8_t IrCommandHardwareControl::getIrLedFrontRightOutput()
{
	
}
void IrCommandHardwareControl::setIrLedFrontRightOutput()
{
	IR_LED_FRONT_RIGHT_OUTPUT;
}
uint8_t IrCommandHardwareControl::getIrLedBackRightOutput()
{
	
}
void IrCommandHardwareControl::setIrLedBackRightOutput()
{
	IR_LED_BACK_RIGHT_OUTPUT;
}
uint8_t IrCommandHardwareControl::getIrLedBackMiddleOutput()
{
	
}
void IrCommandHardwareControl::setIrLedBackMiddleOutput()
{
	IR_LED_BACK_MIDDLE_OUTPUT;
}
uint8_t IrCommandHardwareControl::getIrLedBackLeftOutput()
{
	
}
void IrCommandHardwareControl::setIrLedBackLeftOutput()
{
	IR_LED_BACK_LEFT_OUTPUT;
}
uint8_t IrCommandHardwareControl::getIrLedFrontLeftOutput()
{
	
}
void IrCommandHardwareControl::setIrLedFrontLeftOutput()
{
	IR_LED_FRONT_LEFT_OUTPUT;
}



uint8_t IrCommandHardwareControl::getIrCommunication_Input()
{
	
}
void IrCommandHardwareControl::setIrCommunication_Input()
{
	IR_COMMUNICATION_INPUT;
}





uint8_t IrCommandHardwareControl::getTimer0Config()
{

}
void IrCommandHardwareControl::setTimer0Config()
{
	TIMER0_CONTROL_REGISTER_0A |= NORMAL_TIMER_MODE_TIMER0;
	TIMER0_CONTROL_REGISTER_0B |= CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0;
	RGB_LED_GREEN_OCR = 111-1;
	sei();
}
void IrCommandHardwareControl::setTimer0Off()
{
	TIMER0_CONTROL_REGISTER_0B &= ~CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0;
	cli();
}
void IrCommandHardwareControl::setTimer0On()
{
	TIMER0_CONTROL_REGISTER_0B |= CLOCK_SELECT_BIT_NO_PRESCALING_TIMER0;
	sei();
}
void IrCommandHardwareControl::setTimer0CompareMatchIntOff()
{
	TIMER0_COMPAREMATCH_INTERRUPT &= ~COMPARERMATCH_BIT_ENABLE_INTERRUT;
}
void IrCommandHardwareControl::setTimer0CompareMatchIntOn()
{
	TIMER0_COMPAREMATCH_INTERRUPT |= COMPARERMATCH_BIT_ENABLE_INTERRUT;
}
void IrCommandHardwareControl::setTimer0InitialValue()
{
	TCCR0A &= ~((1<<COM0A1)|(1<<COM0A0)|(1<<COM0B1)|(1<<COM0B0)|(1<<WGM01)|(1<<WGM00));
	TCCR0B &= ~((1<<WGM02)|(1<<CS02)|(1<<CS01)|(1<<CS00));
}





void IrCommandHardwareControl::setIrmpTimer1Config()
{
   // OCR1A   =  (F_CPU / F_INTERRUPTS) - 1;
    TCCR1B  = (1 << WGM12) | (1 << CS10);
	TIMSK1  = (1 << OCIE1A);
}
void IrCommandHardwareControl::setIrmpTimer1Off()
{
	TCCR1B &= ~(1 << CS10);
	cli();	
}
void IrCommandHardwareControl::setIrmpTimer1On()
{
	TCCR1B |= (1 << CS10);
	sei();
}

void IrCommandHardwareControl::setIrmpTimer1InitialValue()
{
	IrCommandHardwareControl::setIrmpTimer1Off();
	TCCR1A &= ~((1<<COM1A1)|(1<<COM1A0)|(1<<COM1B1)|(1<<COM1B0)|(1<<WGM11)|(1<<WGM10));
	TCCR1B &= ~((1<<WGM13)|(1<<WGM12)|(1<<CS12)|(1<<CS11)|(1<<CS10));
	/*cli();*/
}




// 
// 
// IRMP_DATA irmp;
// 
// void getIrmpData()
// {	
// 	irmp_get_data(&irmp);
// }
// 
// void initializeIrmp()
// {
// 	irmp_init();
// }






