/* 
* RobotMotorSpeedDecode.h
*
* Created: 02.10.2015 21:57:47
* Author: Fabio
*/


#ifndef __ROBOTMOTORSPEEDDECODE_H__
#define __ROBOTMOTORSPEEDDECODE_H__

#include <avr/io.h>


#define SPEED_DECODE_HARDWARE_PORT_D						2
#define SPEED_DECODE_IR_LED_LEFT_VAL						PORTD7
#define SPEED_DECODE_IR_LED_RIGHT_VAL						PORTD4

// #define SPEED_DECODE_HARDWARE_PIN_D							PIND
// #define SPEED_DECODE_IR_LED_LEFT_VAL						(1 << DDD2)

// #define SPEED_DECODE_HARDWARE_PIN_C							PINC
// #define SPEED_DECODE_IR_LED_LEFT_VAL						(1 << DDC1)
// #define SPEED_DECODE_IR_LED_RIGHT_VAL						(1 << DDC2)


class RobotMotorSpeedDecode
{
//variables
	public:
	protected:
	private:

//functions
	public:
		RobotMotorSpeedDecode();
		~RobotMotorSpeedDecode();
		
		void speedDecodeInit();
		
		void speedDecodeConfigIO();
		
		
		void speedDecodeWheelLeft();
		void speedDecodeWheelRight();
		
		uint16_t speedDecodeWheelPositionLeft();
		uint16_t speedDecodeWheelPositionRight();
	protected:
	private:
		RobotMotorSpeedDecode( const RobotMotorSpeedDecode &c );
		RobotMotorSpeedDecode& operator=( const RobotMotorSpeedDecode &c );

}; //RobotMotorSpeedDecode

#endif //__ROBOTMOTORSPEEDDECODE_H__
