/* 
* srcMott.h
*
* Created: 04.10.2015 22:23:56
* Author: Fabio
*/

#include <avr/io.h>

#ifndef __SRCMOTT_H__
#define __SRCMOTT_H__

#define OUTPUT			1
#define INPUT			0

#define HIGH			1
#define LOW				0

#define ON				1
#define OFF				0

#define DDR_B			0
#define DDR_C			1
#define DDR_D			2

#define PORT_B			0
#define PORT_C			1
#define PORT_D			2

class srcMott
{
//variables
public:
protected:
private:

//functions
public:
	srcMott();
	~srcMott();
	
	void configIO(int ddr, int pin, int mode);
	void valueIO(int port, int pin, int value);
	
	void configADC(int adcAREF, int adcCS);
	uint16_t valueADC(uint8_t channel);
	void valuePWM();
	
protected:
private:
	srcMott( const srcMott &c );
	srcMott& operator=( const srcMott &c );

}; //srcMott

#endif //__SRCMOTT_H__
