/* 
* motorControlHardwareSetup.cpp
*
* Created: 09.10.2015 18:02:57
* Author: Fabio
*/


#include "motorControlHardwareSetup.h"
#include "C:\Users\Fabio\documents\atmel studio\6.2\Robot Mott\Robot Mott\srcMott\srcMott.h"

srcMott mchssm;

// default constructor
motorControlHardwareSetup::motorControlHardwareSetup()
{
} //motorControlHardwareSetup

// default destructor
motorControlHardwareSetup::~motorControlHardwareSetup()
{
} //~motorControlHardwareSetup

void motorControlHardwareSetup::motorControlHardwareSetupInit()
{
	mchssm.configIO(DDR_D, PORTD6, OUTPUT);
	mchssm.configIO(DDR_D, PORTD5, OUTPUT);
	mchssm.configIO(DDR_B, PORTB2, OUTPUT);
	mchssm.configIO(DDR_B, PORTB1, OUTPUT);
	
	mchssm.configIO(DDR_D, PORTD7, OUTPUT);
	mchssm.configIO(DDR_D, PORTD4, OUTPUT);
	mchssm.configIO(DDR_C, PORTC2, INPUT);
	mchssm.configIO(DDR_C, PORTC1, INPUT);
	
	mchssm.configIO(DDR_D, PORTD3, INPUT);
	mchssm.configIO(DDR_D, PORTD2, INPUT);
}

void motorControlHardwareSetup::motorDirectionHardwareSetupConfigIO(int8_t motor, int8_t motorDriverMode)
{
	switch (motor)
	{
		case MT_LF:
		switch (motorDriverMode)
		{
			case MD_ST:
			mchssm.configOcrIO(OCR0_A, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD6, LOW);
			mchssm.configOcrIO(OCR0_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD5, LOW);
			break;
			case MD_FR:
			mchssm.configOcrIO(OCR0_A, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD6, HIGH);
			mchssm.configOcrIO(OCR0_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD5, LOW);
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			break;
			case MD_BC:
			mchssm.configOcrIO(OCR0_A, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD6, LOW);
			mchssm.configOcrIO(OCR0_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD5, HIGH);
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			break;
			case MD_BR:
			mchssm.configOcrIO(OCR0_A, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD6, HIGH);
			mchssm.configOcrIO(OCR0_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD5, HIGH);
			break;
			case MD_FR_PWM:
			mchssm.configOcrIO(OCR0_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD5, LOW);
			mchssm.configOcrIO(OCR0_A, MOD_FAST_PWM);
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			break;
			case MD_BC_PWM:
			mchssm.configOcrIO(OCR0_A, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTD6, LOW);
			mchssm.configOcrIO(OCR0_B, MOD_FAST_PWM);
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			break;
			//////////////////////////////////////////////////////////////////////////
			// VREF
			//////////////////////////////////////////////////////////////////////////
		}
		break;
		case MT_RG:
		switch (motorDriverMode)
		{
			case MD_ST:
			mchssm.configOcrIO(OCR1_A, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB2, LOW);
			mchssm.configOcrIO(OCR1_B, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB1, LOW);
			break;
			case MD_FR:
			mchssm.configOcrIO(OCR1_A, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB2, HIGH);
			mchssm.configOcrIO(OCR1_B, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB1, LOW);
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			break;
			case MD_BC:
			mchssm.configOcrIO(OCR1_A, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB2, LOW);
			mchssm.configOcrIO(OCR1_B, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB1, HIGH);
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			break;
			case MD_BR:
			mchssm.configOcrIO(OCR1_A, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB2, HIGH);
			mchssm.configOcrIO(OCR1_B, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB1, HIGH);
			break;
			case MD_FR_PWM:
			mchssm.configOcrIO(OCR1_A, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB1, LOW);
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			mchssm.configOcrIO(OCR1_B, MOD_FAST_PWM);
			break;
			case MD_BC_PWM:
			mchssm.configOcrIO(OCR2_B, MOD_NORMAL);
			mchssm.valueIO(PORT_D, PORTD3, HIGH);
			mchssm.configOcrIO(OCR1_B, MOD_NORMAL);
			mchssm.valueIO(PORT_B, PORTB2, LOW);
			mchssm.configOcrIO(OCR1_A, MOD_FAST_PWM);
			break;
		}
		break;
	}
}

void motorControlHardwareSetup::motorDecodeHardwareSetupConfigAdc()
{
	ADMUX = (1<<REFS0);
	ADCSRA = (1<<ADPS1) | (1<<ADPS0);
	ADCSRA |= (1<<ADEN);
	ADCSRA |= (1<<ADSC);
	while (ADCSRA & (1<<ADSC)) { }
	(void) ADCW;
}

void motorControlHardwareSetup::motorControlHardwareSetupConfigTimer0()
{
	
}

void motorControlHardwareSetup::motorControlHardwareSetupConfigTimer1()
{
	
}

void motorControlHardwareSetup::motorControlHardwareSetupConfigTimer2()
{
	
}