/* 
* motorDirection.cpp
*
* Created: 08.10.2015 13:41:13
* Author: Fabio
*/


#include "motorDirection.h"
#include "C:\Users\Fabio\documents\atmel studio\6.2\Robot Mott\Robot Mott\srcMott\specificMott\motorControl\motorControlHardwareSetup\motorControlHardwareSetup.h"

motorControlHardwareSetup mdmchs;

// default constructor
motorDirection::motorDirection()
{
} //motorDirection

// default destructor
motorDirection::~motorDirection()
{
} //~motorDirection

void motorDirection::motorDirectionStandBy()
{
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_ST);
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_ST);
}

void motorDirection::motorDirectionForward()
{
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_FR);
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_FR);
}

void motorDirection::motorDirectionBackward()
{
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_BC);
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_BC);
}

void motorDirection::motorDirectionLeftward()
{
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_BC);
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_FR);	
}

void motorDirection::motorDirectionRightward()
{
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_FR);
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_BC);
}

void motorDirection::motorDirectionBreak()
{
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_BR);
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_BR);
}

void motorDirection::motorDirectionForwardSpeed(uint8_t speedLeft, uint8_t speedRight)
{
	OCR0B = speedLeft;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_BC_PWM);
	OCR1A = speedRight;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_BC_PWM);
}

void motorDirection::motorDirectionBackwardSpeed(uint8_t speedLeft, uint8_t speedRight)
{
	OCR0A = speedLeft;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_FR_PWM);
	OCR1B = speedRight;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_FR_PWM);
}

void motorDirection::motorDirectionLeftwardSpeed(uint8_t speedLeft, uint8_t speedRight)
{
	OCR0A = speedLeft;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_FR_PWM);
	OCR1A = speedRight;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_BC_PWM);

}

void motorDirection::motorDirectionRightwardSpeed(uint8_t speedLeft, uint8_t speedRight)
{
	OCR0B = speedLeft;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_LF, MD_BC_PWM);
	OCR1B = speedRight;
	mdmchs.motorDirectionHardwareSetupConfigIO(MT_RG, MD_FR_PWM);
}

void motorDirection::motorDirectionForwardSpeedGlobal(uint8_t speedLeft, uint8_t speedRight, uint8_t speedGlobal)
{
	
}

void motorDirection::motorDirectionBackwardSpeedGlobal(uint8_t speedLeft, uint8_t speedRight, uint8_t speedGlobal)
{
	
}

void motorDirection::motorDirectionLeftwardSpeedGlobal(uint8_t speedLeft, uint8_t speedRight, uint8_t speedGlobal)
{
	
}

void motorDirection::motorDirectionRightwardSpeedGlobal(uint8_t speedLeft, uint8_t speedRight, uint8_t speedGlobal)
{
	
}
