/* 
* srcMott.h
*
* Created: 08.10.2015 13:36:47
* Author: Fabio
*/


#ifndef __SRCMOTT_H__
#define __SRCMOTT_H__

#include <avr/io.h>

#define OUTPUT			1
#define INPUT			0

#define HIGH			1
#define LOW				0

#define ON				1
#define OFF				0

#define MOD_NORMAL		1
#define MOD_FAST_PWM	0


#define DDR_B			0
#define DDR_C			1
#define DDR_D			2

#define PORT_B			0
#define PORT_C			1
#define PORT_D			2

#define OCR0_A			0
#define OCR0_B			1
#define OCR1_A			2
#define OCR1_B			3
#define OCR2_A			4
#define OCR2_B			5

class srcMott
{
//variables
public:
protected:
private:

//functions
public:
	srcMott();
	~srcMott();
	void configIO(int8_t ddr, int8_t pin, int8_t mode);
	void configOcrIO(int8_t ocr, int8_t mode);
	void valueIO(int8_t port, int8_t pin, int8_t value);
protected:
private:
	srcMott( const srcMott &c );
	srcMott& operator=( const srcMott &c );

}; //srcMott

#endif //__SRCMOTT_H__
