/*
 * asm_rx_rc5.asm
 *
 *  Created: 29.11.2015 00:53:33
 *   Author: Fabio
 */ 


 /*
 * asm_rc5_tx.asm
 *
 *  Created: 21.11.2015 11:58:11
 *   Author: Fabio
 */ 


 .include "m328pdef.inc"


 .equ	rc5halfbittimingflag = 1
 .equ	rc5bittimingflag = 2

  .equ	mask = 7


  

 
   .dseg 
 .org $100

lotim0cnt: .byte 1
hitim0cnt: .byte 1

 .cseg
 .org $00
 rjmp main



 .org INT0addr
	rjmp int0any




 .org OC0Aaddr
	rjmp tim0CTC


 .org $60
 main:

	ldi r16, low(RAMEND)
	out spl, r16
	ldi r16, high(RAMEND)
	out sph, r16

	ldi r21, 0b11110001
	ldi r22, 0b11111100
	ldi r23, 0b10000000

	rcall initRc5Tim

 loop:




 rjmp loop




initRc5Tim:


	ldi r16, 0x01
	sts eicra, r16
	ldi r16, 0x01
	out eimsk, r16
	
	ldi r16, 0x02
	out tccr0a, r16		;tim 0 ctc mode
	ldi r16, 0x02
	out tccr0b, r16		;tim 0 1/8 clock source
	ldi r16, 0x02
	sts timsk0, r16		;tim 0 comparer match A INT
	ldi r16, 0x04
	out ocr0a, r16		;tim 0 TOP <- ocr0a

	sei

 ret






	int0any:


	in r0, sreg




	lsr r17
	lsr r17
	lsr r18
	lsr r18

	ldi r16, 0x03
	mul r17, r16
	sts lotim0cnt, r0
	mul r18, r16
	sts hitim0cnt, r0

	

	clr r17
	clr r18
	
	
	out sreg, r0
	
	
	reti








	tim0CTC:
		in r0, sreg		;store status register
		inc r17			;inc conter low byte
		lds r16, lotim0cnt
		cp r17, r16
		breq ti
		brne tim0CTCexit

		ti:
		clr r17
		
		lds r16, hitim0cnt
		cp r18, r16
		breq ti1
		inc r18			;inc conter low byte
		brne tim0CTCexit

		ti1:
		clr r18
		in r19, pind

/*
		
		cpse r17, r16
		brne tim0
		inc r18			;inc counter high byte
		lds r16, high(tim0cnt)
		tim0:
		cpse r18, r16
		brne tim00
		brne tim0CTCexit
		tim00:
		in r19, pind
		tim01:
		clr r17
		*/
	tim0CTCexit:

		out sreg, r0	;restore status register
	reti