
/*
 * rc5_asm.s
 *
 * Created: 25.11.2015 23:56:05
 *  Author: Fabio
 */ 
 #include <avr/io.h>
// #define __SFR_OFFSET 0
#include "simulOS.h"

tmp = 16

 .global asm_rc5send


 .section .data



 .section .text


 asm_rc5send:
				out PORTD, r16
 ret


// .org $60
 main:

	ldi tmp, lo8(RAMEND)
	out _SFR_IO_ADDR(SPL), tmp
	ldi 16, hi8(RAMEND)
	out _SFR_IO_ADDR(SPH), 16

	ldi r21, 0b11010001
	ldi r22, 0b11001100
	ldi r23, 0b10000000

	rcall initRc5Tim

 loop:




 rjmp loop




initRc5Tim:

	ldi r16, 0x02
	sts tccr0a, r16		;tim 0 ctc mode
	ldi r16, 0x02
	sts tccr0b, r16		;tim 0 1/8 clock source
	ldi r16, 0x02
	sts timsk0, r16		;tim 0 comparer match A INT
	ldi r16, 0x04
	sts ocr0a, r16		;tim 0 TOP <- ocr0a

	ldi r16, 0x02
	sts tccr2a, r16		;tim 2 ctc mode
	ldi r16, 0x01
	sts tccr2b, r16		;tim 2 clock source
	ldi r16, 0x02
	sts timsk2, r16		;tim 2 compare match A INT
	ldi r16, 0x6e
	sts ocr2a, r16		; tim 2 TOP <- ocr2a

	rc5Timing:
	clr r16
	ori r16, !rc5halfbittimingflag
	eor r1, r16
	sts rc5flags, r1
//	ori r16, !rc5bittimingflag
	clr r17
	clr r18
	clr r19
	sei

 ret








	tim2CTC:
		lds r0, sreg
		lds r1, rc5flags
		sbrs r1, 0
		breq rc5send1
		sbrc r1, 0
		breq rc5send2
	rc5send1:	;low
		mov r25, r21
		and r25, r23
		cpse r25, r23
		breq rc5send4
		brne rc5send3
	rc5send2:	;high
		mov r25, r21
		com r25
		and r25, r23
		cpse r25, r23
		breq rc5send4
		brne rc5send3
	rc5send3:	;off
		sts portd, 7
		brne tim2CTCexit
	rc5send4:	;toggle
		lds r1, portd
		ori r16, 128
		eor r1, r16
		sts portd, r1
	tim2CTCexit:
		sts sreg, r0
 reti




	tim0CTC:
		lds r0, sreg		;store status register
		inc r17			;inc conter low byte
		brne rc5Timing1
		inc r18			;inc counter high byte
	rc5Timing1:
		cpi r18, 0x00
		brlo tim0CTCexit
	rc5Timing2:
		cpi r17, 0xb1
		brlo tim0CTCexit
	rc5Timing3:
		lds r1, rc5flags
		ori r16, rc5halfbittimingflag
		eor r1, r16
		sts rc5flags, r1
		clr r16
		ori r16, rc5bittimingflag
		eor r1, r16
		sts rc5flags, r1
		clr r16
		clr r17
		clr r18
		sbrs r1, 1
		lsr r23
		brlo rc5timing4
		jmp tim0CTCexit
	rc5timing4:
		ldi r23, 0x80
		mov r21, r22
	tim0CTCexit:
		sts sreg, r0	;restore status register
	reti

