/*
 * rc5_tx.h
 *
 * Created: 04.01.2016 23:07:06
 *  Author: Fabio
 */ 


#ifndef RC5_TX_H_
#define RC5_TX_H_

#ifdef __cplusplus
extern "C" {
	#endif


	#ifdef __ASSEMBLER__

#define zeroreg		r0

#define inreg		r2

#define rc5tmpflag		r4
#define rc5hibyte		r5
#define rc5lobyte		r6
#define rc5mask		r7
#define rc5bits		r8

#define rc5lotim		r9
#define rc5hitim		r10
#define rc5decodefalg	r11
#define rc5decodemask	r12
#define rc5decodecomdlo		r21		//r13
#define rc5decodecomdhi		r23		//r14
#define rc5decodebits		r15

#define rc5tmp		r16
#define rc5cnt		r17

#define lotimcnt		r18
#define hitimcnt		r19

#define c_rc5led		r20
#define c_rc5lobyte		r22
#define c_rc5hibyte		r24

#else

#include <stdint.h>

extern void init_rc5_tx_asm();

extern void asm_rc5send();

#endif


#ifdef __cplusplus
}

#endif

#endif /* RC5_TX_H_ */