$fs = 0.1;
$fa = 1;  



module chassisBody() {
    color("Lime") translate([0,0,-2]) cylinder(h=4, r=27, center=true, $fn=100);
}


module motorshaft(){
color("red")
    translate([0,0,-1.5]) 
    linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-13,-5.5],[13,-5.5],[13,5.5],[-13,5.5],[-13,-5.5]]);}
}

module wheelhole(){
color("orange")
    translate([0,0,-2]) 
    linear_extrude(height = 4, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-9,-7.5],[9,-7.5],[9,7.5],[-9,7.5],[-9,-7.5]]);}
}

module motorholder(){
color("purple")
    translate([0,0,-4]) 
    linear_extrude(height = 8, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-5,-5.5],[5,-5.5],[5,5.5],[-5,5.5],[-5,-5.5]]);}
}

module motorhole(){
color("blue")
    rotate([0,90,0]) 
    translate([3,0,-3]) 
    linear_extrude(height = 18, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 4, $fn=200);}
}
module motorcut(){
color("purple")
    translate([0,0,-7.5]) 
    linear_extrude(height = 2.5, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-5,-5.5],[5,-5.5],[5,5.5],[-5,5.5],[-5,-5.5]]);}
}

module mothold(){
     
    difference(){
        motorholder();
        motorhole(); 
        motorcut();      
        }
}

module motorposholder(){
color("blue")
    translate([0,0,-2.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=100){
    polygon(points = [[-3,-1],[3,-1],[3,1],[-3,1],[-3,-1]]);}
}
module motorposhole(){
color("red")
    rotate([90,90,0]) 
    translate([3,0,-0.6]) 
    linear_extrude(height = 3.5, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1, $fn=100);}
}

module motorpos(){
difference() {
        motorposholder();
        motorposhole();
        
        }
}
module holeai(){
color("pink")
    translate([0,0,0]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.2, $fn=100);}
    }
module holeao(){
color("red")
    translate([0,0,0]) 
    linear_extrude(height = 15, center = true, convexity = 10, twist = 0, $fn=100){
    circle(r = 1.75, $fn=100);}  
    }
    
module holea(){
    difference() {
    holeao();
       holeai();
        
        }

}



module diff(){
    
    difference() {
        chassisBody();
translate([-2,6.5,-1]) motorshaft();
translate([2,-6.5,-1]) motorshaft();
translate([0,-19.5,0]) wheelhole();
translate([0,19.5,0]) wheelhole();
translate([-15,-5,-4]) motorhole();
translate([21,5,-4]) motorhole();

        }
    
    
    }
    
module add()
    {
translate([-20,-5,-4]) mothold();
translate([20,5,-4]) mothold();
translate([5,-0,-4]) motorpos();
rotate([0,0,180]) translate([5,0,-4]) motorpos();
translate([10.5,-15.5,-9]) holea();
translate([18,14,-9]) holea();
translate([-17,-15.5,-9]) holea();
translate([-11.5,16.5,-9]) holea();
color("Lime") translate([0,0,1]) cylinder(h=2, r=28, center=true, $fn=200);
}
  

module chas()
    {
    add();
diff();
}


module sc() 
{
        difference()
    {
        chas();
        translate([10.5,-15.5,-3]) holeai();
translate([18,14,-3]) holeai();
translate([-17,-15.5,-3]) holeai();
translate([-11.5,16.5,-3]) holeai(); 
        
        }
    
}

sc();







