$fs = 0.1;
$fa = 1;  

module motorbody(){
    
    color("Lime") translate([0,0,0]) cube(size = [16.5, 11, 12], center = true);
    color("Lime") translate([15.25,1.5,0]) rotate([0,90,0]) cylinder(h=14, r=4, center=true, $fn=100);
    
    color("Lime") translate([-3.25,-7.5,0]) rotate([90,0,0]) cylinder(h=3, r=1.5, center=true, $fn=100);
    color("Lime") translate([-3.25,-5.75,0]) rotate([90,0,0]) cylinder(h=0.5, r=2.5, center=true, $fn=100);
    
    color("Lime") translate([2.25,5.75,0]) rotate([90,0,0]) cylinder(h=0.5, r=1.2, center=true, $fn=100);
    
    translate([-3.25,-14,0]) rotate([270,0,0]) #wheelbody();
}

module wheelbody(){
    
    
    difference(){
color("Lime") translate([0,0,0]) cylinder(h=8, r=10, center=true, $fn=100); 
wheeldecodde();

}
wheelholder();
}


module wheeldecodde(){

union(){
    for(a = [0 : 30 : 360]){
        color("orange") rotate([0,0,a]) translate([0,0,0]) linear_extrude(height = 4, center = true, convexity = 10) {
        polygon(points=[[0,0],[15,0],[15,4.0192378864668405970883048774119],[0,0]], convexity=10);
            }
    }  
    
    color("orange") translate([0,0,0]) cylinder(h=4, r=3, center=true, $fn=100);
    color("orange") translate([0,0,4.5]) cylinder(h=5, r=1.5, center=true, $fn=100);
    
    difference(){
        color("orange") translate([0,0,0]) cylinder(h=4, r=15, center=true, $fn=100);
        color("orange") translate([0,0,0]) cylinder(h=4, r=9, center=true, $fn=100);
    }
}
}


module wheelholder(){
    difference(){ 
    color("blue") translate([0,0,6]) cylinder(h=4, r=3, center=true, $fn=100); 
    color("red") translate([0,0,6]) cylinder(h=4, r=1.5, center=true, $fn=100); 
}

}

module chassibody(){
    
 difference(){
     
     
     union(){
        color("lime") translate([0,0,-6.5]) cylinder(h=5, r=26, center=true, $fn=100); 
        
         union(){
            color("lime") translate([16.5,-5.75,-3.75]) cube(size = [10, 3.5, 2.5], center = true);
            color("lime") translate([16.5,-10,-4.15]) rotate([15,0,0]) cube(size = [10, 9, 2], center = true);
                difference(){
                    color("red") translate([16.5,-4.5,1.5]) cube(size = [10, 16, 11], center = true);
                    color("red") translate([16.5,-16,-1]) cube(size = [10.5, 24, 6], center = true);
                    color("lime") translate([16.5,-10,2]) rotate([-15,0,0]) cube(size = [10.5, 9, 2], center = true);
                union(){
        difference(){
            color("Lime") translate([16.5,-4.5,-1]) rotate([0,90,0]) cylinder(h=10.5, r=11.5, center=true, $fn=100);
        color("Lime") translate([16.5,-4.5,-1]) rotate([0,90,0]) cylinder(h=10.5, r=8, center=true, $fn=100);
        color("red") translate([16.5,-4.5,-6.5]) cube(size = [10.5, 24, 12], center = true);
                    }         
                        }

                            }
               } 
              rotate([0,0,180])         union(){
            color("lime") translate([16.5,-5.75,-3.75]) cube(size = [10, 3.5, 2.5], center = true);
            color("lime") translate([16.5,-10,-4.15]) rotate([15,0,0]) cube(size = [10, 9, 2], center = true);
                difference(){
                    color("red") translate([16.5,-4.5,1.5]) cube(size = [10, 16, 11], center = true);
                    color("red") translate([16.5,-16,-1]) cube(size = [10.5, 24, 6], center = true);
                    color("lime") translate([16.5,-10,2]) rotate([-15,0,0]) cube(size = [10.5, 9, 2], center = true);
                union(){
        difference(){
            color("Lime") translate([16.5,-4.5,-1]) rotate([0,90,0]) cylinder(h=10.5, r=11.5, center=true, $fn=200);
        color("Lime") translate([16.5,-4.5,-1]) rotate([0,90,0]) cylinder(h=10.5, r=8, center=true, $fn=100);
        color("red") translate([16.5,-4.5,-6.5]) cube(size = [10.5, 24, 12], center = true);
                    }         
                        }

                            }
               } 
            }
            
            
            
            
     //color("Lime") translate([16.5,-4.5,0]) rotate([0,90,0]) cylinder(h=10, r=7, center=true, $fn=100);
    color("blue") translate([0,-20.5,-6.5]) cube(size = [22, 11, 5.5], center = true);
    color("blue") rotate([0,0,180]) translate([0,-20.5,-6.5])  cube(size = [22, 11, 5.5], center = true);
            
            color("lime") translate([3.25,-16.5,-5]) cube(size = [16.5, 16, 2], center = true);
            color("lime") rotate([0,0,180]) translate([3.25,-16.5,-5])  cube(size = [16.5, 16, 2], center = true);
            
translate([3.25,-6,0]) motorbody();

translate([-3.25,6,0]) rotate([0,0,180]) motorbody();

}

}

chassibody();








