$fs = 0.1;
$fa = 1;  



module holderMainRing() {
    
    difference()
    {
    color("Red") cylinder(h=1.5, r=26.5, center=true, $fn=100);
    color("White") cylinder(h=2.1, r=25.5, center=true, $fn=100);    
    }
    translate([0,0,-1.5])
    difference()
    {
    color("Blue") cylinder(h=1.5, r=26.5, center=true, $fn=100);
    color("White") cylinder(h=2, r=24, center=true, $fn=100);    
    }
    translate([0,0,-5])
    difference()
    {
    color("lime") cylinder(h=5.5, r=26.5, center=true, $fn=100);
    color("White") cylinder(h=6, r=18.5, center=true, $fn=100);    
    }

    
}
translate([0,0,-15.75]) mainbase();
module mainbase(){
    
    difference(){
            color("Red") cylinder(h=0.5, r=27.5, center=true, $fn=100);
            color("White") cylinder(h=1.1, r=17, center=true, $fn=100);  
        
        
        }
    
    
    }
module sensorHole() {
    rotate([0,0,0])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,60])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,120])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,180])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,240])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    rotate([0,0,300])
    translate([0,0,-6.25])
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    color("Orange") polygon(points=[[20.25,3.25],[27,3.25],[27,-3.25],[20.25,-3.25],[20.25,3.25]], $fn=100);
    
}

module holecut() {
    rotate([0,0,45])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,105])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,165])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,225])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,285])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    rotate([0,0,345])     translate([0,0,-6])
    color("Green") 
    linear_extrude(height = 7, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[0,0],[28,0],[28,-16.1658],[0,0]], $fn=100);
    
}







module holeai(){
color("pink")
    translate([0,0,0]) 
    linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 1.35, $fn=200);}
    }
module holeao(){
color("red")
    translate([0,0,0.5]) 
    linear_extrude(height = 3, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}  
color("blue")
    translate([0,0,3]) 
    linear_extrude(height = 2, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}
color("blue")        translate([0,0,3]) 
    linear_extrude(height = 2, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}
color("blue")       translate([3,0,4.5]) 
    linear_extrude(height = 5, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2, $fn=200);}
    color("blue")
    translate([1.5,0,3]) 
    linear_extrude(height = 2, center = true, convexity = 10, twist = 0, $fn=200){
    polygon(points = [[-1.5,-2],[1.5,-2],[1.5,2],[-1.5,2],[-1.5,-2]]);}
    
    }

module holea(){
    difference() {
    translate([0,0,3]) holeao();
    translate([0,0,3]) holeai();
 color("red")
    translate([0,0,10.5]) 
    linear_extrude(height = 7, center = true, convexity = 10, twist = 0, $fn=200){
    circle(r = 2.1, $fn=200);}
    }
}




module suport(){


color("yellow") 
   
      rotate([0,0,0]) 
    union(){
    for(a= [0: 5: 360]){
        
   rotate([0,0,a])
    translate([26,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    
    
    
    for(a= [0: 5: 360]){
        if(a < 50){
   rotate([0,0,a])
    translate([19.5,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 60 && a< 145){
   rotate([0,0,a])
    translate([19.5,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 140 && a< 230){
   rotate([0,0,a])
    translate([19.5,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 240 && a< 320){
   rotate([0,0,a])
    translate([19.5,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 315 && a< 360){
   rotate([0,0,a])
    translate([19.5,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }



    for(a= [0: 5: 360]){
        if(a < 55){
   rotate([0,0,a])
    translate([22,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 55 && a< 135){
   rotate([0,0,a])
    translate([22,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 140 && a< 235){
   rotate([0,0,a])
    translate([22,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 240 && a< 320){
   rotate([0,0,a])
    translate([22,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 325 && a< 360){
   rotate([0,0,a])
    translate([22,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }


    for(a= [0: 5: 360]){
        if(a < 135){
   rotate([0,0,a])
    translate([24,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }

        for(a= [0: 5: 360]){
        if(a > 140 && a< 230){
   rotate([0,0,a])
    translate([24,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 225 && a< 320){
   rotate([0,0,a])
    translate([24,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
        for(a= [0: 5: 360]){
        if(a > 325 && a< 360){
   rotate([0,0,a])
    translate([24,0,-11]) 
    linear_extrude(height = 9, center = true, convexity = 10, twist = 0, $fn=10){
    circle(r = 0.4, $fn=10);}
    }
    }
}

}










difference(){
holderMainRing();
holecut();

sensorHole();
    color("red")
    translate([10.5,15.5,-8]) rotate([0,0,60])
    //linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    //circle(r = 2.6, $fn=200);}
        linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[2,2],[-2,2],[-2,-2],[2,-2],[2,2]], $fn=100);
    color("red")
    translate([18,-14,-8]) rotate([0,0,45])
    //linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    //circle(r = 2.6, $fn=200);}
    linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[2,2],[-2,2],[-2,-2],[2,-2],[2,2]], $fn=100);
    
    color("red")
    translate([-17.5,14.5,-8]) rotate([0,0,45])
    //linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    //circle(r = 2.6, $fn=200);}
 linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[2,2],[-2,2],[-2,-2],[2,-2],[2,2]], $fn=100);
    
    color("red")
    translate([-11.5,-16.5,-8]) rotate([0,0,55])
    //linear_extrude(height = 8.5, center = true, convexity = 10, twist = 0, $fn=200){
    //circle(r = 2.6, $fn=200);}
     linear_extrude(height = 9, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[2,2],[-2,2],[-2,-2],[2,-2],[2,2]], $fn=100);
}








translate([10.5,15.5,-17.5]) rotate([0,0,360])  holea();
translate([18,-14,-17.5])  rotate([0,0,140]) holea();
translate([-17,15.5,-17.5]) rotate([0,0,320]) holea();
translate([-11.5,-16.5,-17.5]) rotate([0,0,180])holea();
translate([18.5,14.5,-6]) rotate([0,0,-44]) lsens();
translate([18.5,-14.5,-6]) rotate([0,0,44]) lsens();
translate([-18.5,-14.5,-6]) rotate([0,0,-44]) lsens();
translate([-18.5,14.5,-6]) rotate([0,0,44]) lsens();


module lsens (){
    difference(){
    color("Orange")
    linear_extrude(height = 4, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[4.25,2],[-4.25,2],[-4.25,-2],[4.25,-2],[4.25,2]], $fn=100);
    color("blue")
    linear_extrude(height = 4.1, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[2.85,0.85],[-2.85,0.85],[-2.85,-0.85],[2.85,-0.85],[2.85,0.85]], $fn=100);
    color("blue")
    linear_extrude(height = 4.1, center = false, convexity = 10, twist = 0, $fn=100)
    polygon(points=[[1.85,2],[-1.85,2],[-1.85,-2],[1.85,-2],[1.85,2]], $fn=100);
    }
}


suport();


