



$fs = 0.1;
$fa = 1;  



module wheelBody() {
    color("Lime") cylinder(h=4, r=6.5, center=true, $fn=200);
}


module driveShaft() {
    
    color("Red") translate([0,0,0.5]) cylinder(h=7, r=2, center=true, $fn=200);
    
    }

module driveHole() {
    
    color("Orange") translate([0,0,0.5]) cylinder(h=7, r=1.1, center=true, $fn=200);
    
    }

module wheelTorus() {
    
    color("Blue") rotate_extrude(convexity = 10, $fn = 200)
    translate([6.5, 0, 0])
    circle(r = 1.5, $fn = 100);
    
    }
    
   
    
    module wheel() {
        
        wheelBody();
        driveShaft();
    }


    module xy() {
    difference() {
    
    wheel();
    driveHole();    
    wheelTorus();
    }
} 
 
   
   
   
   
   xy();
   
   
   
   
   module decodeOut() {
       
       color("Teal") cylinder(h=3.5, r=7.5, center=true, $fn=200);
       
       }



       module decodeIn() {
           
       color("Purple") cylinder(h=3.5, r=6.5, center=true, $fn=200);
           
           }
   module decodeOutIn(){    
           difference() {
       decodeOut();
        decodeIn();
           }
       }




module decodePolygon() {
    difference() {/*2.2744*/
        translate([0,0,-0.5]) polygon( points=[[0,0],[8,0],[8,2.599],[0,0]] );
        translate([0,0,-0.5]) polygon( points=[[0,-1],[3,0],[3,3],[0,3],[0,0]] );
    }
}

module decodePart() {
    linear_extrude(height = 3.5, center = false, convexity = 10, twist = 0, $fn=200) decodePolygon();
}

//rotate([0,0,0]) decodePart();
//rotate([0,0,36]) decodePart();


module decodePartDiff() {

rotate([0,0,0]) decodePart();
rotate([0,0,36]) decodePart();
rotate([0,0,72]) decodePart();
rotate([0,0,108]) decodePart();
rotate([0,0,144]) decodePart();
rotate([0,0,180]) decodePart();
rotate([0,0,216]) decodePart();
rotate([0,0,252]) decodePart();
rotate([0,0,288]) decodePart();
rotate([0,0,324]) decodePart();

}


//decodePartDiff();




module move() {
    

    translate([0,0,-2]) decodePartDiff();
    }



module decode() {
    
difference() {
decodeOutIn();
    move();

}
}



module mov()  {
    translate([0,0,-3]) decode();
    
    }
    
    
    
    
    
    
    
    
    
    
   
    
    
    
    
    
    
    
    
    
    
    
    
    
    

module wheelIn() {
    color("Blue") rotate_extrude(convexity = 10, $fn = 200)
    translate([6.5, 0, 0])
    circle(r = 1.5, $fn = 200);
    }
    
    
  
    
    
module wheelOut() {
    
    color("Lime") rotate_extrude(convexity = 10, $fn = 200)

   
       polygon( points=[[6.5,1.5],[7.5,1.5],[8,1],
                     [8,-1],[7.5,-1.5],[6.5,-1.5],[6.5,1.5]],  $fn = 200);
   
    }
    
    
    


    
    
module kerbe() {
    
    color("Red") rotate_extrude(convexity = 10, $fn = 200) 
    polygon( points=[[6,0.2],[8,0.2],[8,-0.2],
                     [6,-0.2],[6,0.2]],  $fn = 200); 
    
    }
   

module diff() {
    
    difference(){
        wheelIn();
        wheelOut();
             
        }
    } 
    
module diff1() {
    
    difference(){
        wheelOut();
        kerbe();
             
        }
    } 
    
    
module wheell() {
    
        diff();
    diff1();
    
    }
    


    
    
    
    
    
    
    
     mov();
    wheell();
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
