/*
 * GccApplication11.c
 *
 * Created: 17.08.2014 15:25:10
 *  Author: Fabio
 */ 


#include <avr/io.h>
#include <avr/interrupt.h>
#define F_CPU 8000000UL

#include <util/delay.h>

 //volatile uint16_t rc5Command =        0b00000000000000;
//uint16_t rc5Code =           0b00000000000000;

//volatile uint16_t rc5CommandBits =       0x2000;	
uint16_t rc5CodeBits =          0x20;

uint8_t rc5CodeMSB =		5;
uint8_t rc5CodeLSB =		0;



//#define xxxx _rc5Avaible.rc5CodeAvaible == 1 &&_rc5Command.rc5StartBit == 1 &&_rc5Command.rc5FieldBit == 1 &&_rc5Command.rc5ToggleBit == 1 &&_rc5Command.rc5AddressBit == 31 &&_rc5Command.rc5CodeBit == 63

//#define xxxxx _rc5Command.

	 typedef struct rc5StartBits{
		 uint8_t rc5StartBit :     0b1;  //1
		 uint8_t rc5FieldBit :     0b1;  //1
		 uint8_t rc5ToggleBit :    0b1;  //1
	 }sb;

	 sb rc5StartBitsk  = {.rc5StartBit = 1,
											 .rc5FieldBit = 1,
											 .rc5ToggleBit = 1};
											 
	 struct rc5StartBits rc5ReceivedStartBits = {.rc5StartBit = 1,
												.rc5FieldBit = 1,
												.rc5ToggleBit = 1};	
	 

	//_rc5StartBits = {.rc5StartBit = 1};
	
	
	typedef struct {
		uint8_t rc5AddressBit4 :   0b1;  // 1
		uint8_t rc5AddressBit3 :   0b1;  // 1
		uint8_t rc5AddressBit2 :   0b1;  // 1
		uint8_t rc5AddressBit1 :   0b1;  // 1
		uint8_t rc5AddressBit0 :   0b1;  // 1
	}rc5AddressBits;
	
	 const rc5AddressBits rc5LocalAddressBits = {.rc5AddressBit4 = 1,
												 .rc5AddressBit3 = 1,
												 .rc5AddressBit2 = 1,
												 .rc5AddressBit1 = 2,
												 .rc5AddressBit0 = 1};
												 
	 rc5AddressBits rc5ReceivedAddressBits = {.rc5AddressBit4 = 1,
													.rc5AddressBit3 = 1,
													.rc5AddressBit2 = 1,
													.rc5AddressBit1 = 2,
													.rc5AddressBit0 = 1};	
	
#define rc5RobotAddress (rc5LocalAddressBits.rc5AddressBit4 = 1) && (rc5LocalAddressBits.rc5AddressBit3 = 1) && (rc5LocalAddressBits.rc5AddressBit2 = 1) && (rc5LocalAddressBits.rc5AddressBit1 = 1) && (rc5LocalAddressBits.rc5AddressBit0 = 1)

	
	 typedef struct rc5CodeBits{
		 uint8_t rc5CodeBit5 :  0b1;  //1
		 uint8_t rc5CodeBit4 :  0b1;  //1
		 uint8_t rc5CodeBit3 :  0b1;  //1
		 uint8_t rc5CodeBit2 :  0b1;  //1
		 uint8_t rc5CodeBit1 :  0b1;  //1
		 uint8_t rc5CodeBit0 :  0b1;  //1
	 };	
	 
	struct rc5CodeBits rc5SendCodeBits = {.rc5CodeBit5 = 1,
										  .rc5CodeBit4 = 1,
								          .rc5CodeBit3 = 1,
								          .rc5CodeBit2 = 1,
								          .rc5CodeBit1 = 1,
								          .rc5CodeBit0 = 1};
		 
	struct rc5CodeBits rc5ReceivedCodeBits = {.rc5CodeBit5 = 1,
											  .rc5CodeBit4 = 1,
											  .rc5CodeBit3 = 1,
											  .rc5CodeBit2 = 1,
											  .rc5CodeBit1 = 1,
											  .rc5CodeBit0 = 1};	 
	 



typedef struct rc5{	
	
		uint8_t rc5StartBit :     0b1;  //1
		uint8_t rc5FieldBit :     0b1;  //1
		uint8_t rc5ToggleBit :    0b1;  //1
		uint8_t rc5AddressBit4 :  0b1;  //1
		uint8_t rc5AddressBit3 :  0b1;  //1
		uint8_t rc5AddressBit2 :  0b1;  //1
		uint8_t rc5AddressBit1 :  0b1;  //1
		uint8_t rc5AddressBit0 :  0b1;  //1
		uint8_t rc5CodeBit5 :	  0b1;  //1
		uint8_t rc5CodeBit4 :	  0b1;  //1
		uint8_t rc5CodeBit3 :	  0b1;  //1
		uint8_t rc5CodeBit2 :	  0b1;  //1		
		uint8_t rc5CodeBit1 :	  0b1;  //1		
		uint8_t rc5CodeBit0 :	  0b1;  //1			
		
			
//_rc5AddressBits rc5addbit = {.rc5AddressBit4 = 1};	

	uint16_t rc5Command :        0b1110; //14
	
	uint8_t rc5CodeAvaible :     0b1;    // 1
	 
	};
	
	struct rc5 rc5SendCommand = {.rc5StartBit	= 0,
					             .rc5FieldBit	= 0,
					             .rc5ToggleBit = 0,
					             .rc5AddressBit4 = 0,
					             .rc5AddressBit3 = 0,
					             .rc5AddressBit2 = 0,
					             .rc5AddressBit1 = 0,
					             .rc5AddressBit0	= 0,
					             .rc5CodeBit5	= 0,
					             .rc5CodeBit4	= 0,
					             .rc5CodeBit3	= 0,
					             .rc5CodeBit2	= 0,
					             .rc5CodeBit1	= 0,
					             .rc5CodeBit0 = 0};
					   
	struct rc5 rc5ReceivedCommand = {.rc5StartBit	= 0,
									 .rc5FieldBit	= 0,
									 .rc5ToggleBit = 0,
									 .rc5AddressBit4 = 0,
									 .rc5AddressBit3 = 0,
									 .rc5AddressBit2 = 0,
									 .rc5AddressBit1 = 0,
									 .rc5AddressBit0	= 0,
									 .rc5CodeBit5	= 0,
									 .rc5CodeBit4	= 0,
									 .rc5CodeBit3	= 0,
									 .rc5CodeBit2	= 0,
									 .rc5CodeBit1	= 0,
									 .rc5CodeBit0 = 0};	
	

	

//_rc5 rc5CommandBits = {.rc5ToggleBit = 1 };

//_rc5CommandBits rc5CommandBit;

//_rc5 _rc5Command = {.rc5StartBit = 1, .rc5FieldBit = 1, .rc5ToggleBit = 1, .rc5AddressBit = 31, .rc5CodeBit = 63};
 /* 
_rc5AddressBits rc5AddressBits = {.rc5CodeAvaible = -1};
 
_rc5 _rc5Avaible = {.rc5CodeAvaible = -1};
	
_rc5 full = {.rc5Command = 16383};	
*/
uint16_t command;
uint16_t commandbit = 0x2000;

 //const uint16_t xx = rc5Command.rc5CodeBit;

//const uint16_t xx = rc5Avaible.rc5CodeAvaible == 1 &&rc5Command.rc5StartBit == 1 &&rc5Command.rc5FieldBit == 1 &&rc5Command.rc5ToggleBit == 1 &&rc5Command.rc5AddressBit == 31 &&rc5Command.rc5CodeBit == 63;

int main(void)
{
	DDRD &= ~(1 << PD2);
	DDRD |= (1 << PD6);
	
	PORTD |= (1 << PORTD2) | (1 << PD6);
	
	DDRB |= (1 << PB1) | (1 << PB2);
	PORTB |= (1 << PB1) | (1 << PB2);
	/*
		if (_rc5StartBits.rc5StartBit == 1)
		{
			_rc5.rc5StartBit = 1;
		}
		if (_rc5StartBits.rc5FieldBit == 1)
		{
			_rc5.rc5FieldBit = 1;
		}
		if (_rc5StartBits.rc5ToggleBit == 1)
		{
			_rc5.rc5ToggleBit = 1;
		}
		
		
		if (_rc5AddressBits.rc5AddressBit4 == 1)
		{
			_rc5.rc5AddressBit4 = 1;
		}
		if (_rc5AddressBits.rc5AddressBit3 == 1)
		{
			_rc5.rc5AddressBit3 = 1;
		}
		if (_rc5AddressBits.rc5AddressBit2 == 1)
		{
			_rc5.rc5AddressBit2 = 1;
		}
		if (_rc5AddressBits.rc5AddressBit1 == 1)
		{
			_rc5.rc5AddressBit1 = 1;
		}
		if (_rc5AddressBits.rc5AddressBit0 == 1)
		{
			_rc5.rc5AddressBit0 = 1;
		}
			
			
		if (_rc5CodeBits.rc5CodeBit5 == 1)
		{
			_rc5.rc5CodeBit5 = 1;
		}
		if (_rc5CodeBits.rc5CodeBit4 == 1)
		{
			_rc5.rc5CodeBit4 = 1;
		}
		if (_rc5CodeBits.rc5CodeBit3 == 1)
		{
			_rc5.rc5CodeBit3 = 1;
		}
		if (_rc5CodeBits.rc5CodeBit2 == 1)
		{
			_rc5.rc5CodeBit3 = 1;
		}
		if (_rc5CodeBits.rc5CodeBit1 == 1)
		{
			_rc5.rc5CodeBit1 = 1;
		}			
		if (_rc5CodeBits.rc5CodeBit0 == 1)
		{
			_rc5.rc5AddressBit0 = 1;
		}		
			
								
		*/
	/*
	if (_rc5Avaible.rc5CodeAvaible == 1)
	{
		command |= ((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
		
	}
	else if (!(_rc5Avaible.rc5CodeAvaible == 1))
	{
		command &= ~((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
	}
	
	
	if (_rc5Avaible.rc5FieldBit == 1)
	{
		command |= ((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
		
	}
	else if (!(_rc5Avaible.rc5FieldBit == 1))
	{
		command &= ~((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
	}
	
	
	if (_rc5Avaible.rc5ToggleBit == 1)
	{
		command |= ((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
		
	}
	else if (!(_rc5Avaible.rc5ToggleBit == 1))
	{
		command &= ~((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
	}	
	
	
	if (_rc5Avaible.rc5AddressBit == 1)
	{
		command |= ((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
		
	}
	else if (!(_rc5Avaible.rc5AddressBit == 1))
	{
		command &= ~((uint16_t)1 << commandbit);
		commandbit = (commandbit >> (uint16_t)1);
	}	
	
	
	
	
	
	
	
	
	
	
	

	full.rc5Command = 0;
	*/
	//TCCR0A |= (1 << WGM01);
  
	
  
	//OCR0A = 111-1;
  
	//TIMSK0 |= (1<<OCIE0A);
	
	
	EICRA |= (1 << ISC00);
	  
	EIMSK |= (1 << INT0);
	
	//TCCR0B |= (1 << CS00); 
	  
	//TIMSK0 |= (1 << TOIE0);
	
	sei();
	  
    while(1)
    {
		
	/*	
		if (rc5RobotAddress == ((rc5ReceivedAddressBits.rc5AddressBit4 == 1) && (rc5ReceivedAddressBits.rc5AddressBit3 == 1) && (rc5ReceivedAddressBits.rc5AddressBit2 == 1) && (rc5ReceivedAddressBits.rc5AddressBit1 == 1) && (rc5ReceivedAddressBits.rc5AddressBit0 == 1)))
		{
			PORTD ^= (1 << PD6);

		}
		*/
	
	
	if ((rc5LocalAddressBits.rc5AddressBit4 && rc5LocalAddressBits.rc5AddressBit3 && rc5LocalAddressBits.rc5AddressBit2 && rc5LocalAddressBits.rc5AddressBit1 && rc5LocalAddressBits.rc5AddressBit0)
    == (rc5ReceivedAddressBits.rc5AddressBit4 && rc5ReceivedAddressBits.rc5AddressBit3 && rc5ReceivedAddressBits.rc5AddressBit2 && rc5ReceivedAddressBits.rc5AddressBit1 && rc5ReceivedAddressBits.rc5AddressBit0))
	{
		PORTD ^= (1 << PD6);
	}
		_delay_ms(1000);
		
		
		
		
		
		
		
		
		
		
		
		
/*		
		if (xxxx)
		{
			PORTD ^= (1 << PD6);
			_rc5Avaible.rc5CodeAvaible = -1;
		}
		
		_delay_ms(1000);
		
		if(_rc5Avaible.rc5CodeAvaible == -1)
		{
			_rc5Avaible.rc5CodeAvaible = 1;
		}
			
			

		if ((rc5Command.rc5StartBit = 1))
		{
			//stomacher
		}
		
	
		if (rc5Command & 0x3F)
		{//
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x3E)
		{	PORTD |= (1 << PD6);
			PORTB |= (1 << PB1);
			PORTB &= ~(1 << PB2);
			rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
				
	    if (rc5Command & 0x3D)
		{	
			PORTB |= ((1 << PB1) | (1 << PB2));
			PORTD &= ~(1 << PD6);
			rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}	
			
		if (rc5Command & 0x3C)
		{   PORTD |= (1 << PD6);
			PORTB |= (1 << PB2);
			PORTB &= ~(1 << PB1);
			rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x3B)
		{//PORTB ^= (1 << PB1);
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x3A)
		{
			//PORTB ^= (1 << PB2);
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}					
		if (rc5Command & 0x39)
		{//PORTD ^= (1 << PD6);
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x38)
		{//PORTB ^= (1 << PB1);
			
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}
		
		if (rc5Command & 0x37)
		{
			//PORTB ^= (1 << PB2);
			//rc5Command = 0b00000000000000;
			//rc5CommandBits = 0b10000000000000;

		}				
		*/
        //TODO:: Please write your application code 
    }
}
volatile uint8_t interruptExt = 0;///////////////////
uint8_t compareMatchCounterHigh = 0;
uint8_t compareMatchCounterLow = 0;

uint16_t rc5CommandLength = 0b10000000000000;

volatile uint8_t rc5HalfbitTimeAvaible = 0;
volatile uint8_t rc5HalfbitTime = 0;
volatile uint8_t rc5HalfbitTimeUndWenig = 0;

volatile uint8_t rc5HalfbitTimex = 0;
volatile uint8_t rc5HalfbitTimeUndWenigx = 0;
volatile uint8_t rc5HalfbitTimey = 0;
volatile uint8_t rc5HalfbitTimeUndWenigy = 0;

volatile uint8_t rc5HalfbitTransmition = 0;
volatile uint8_t rc5LastReadBit = 0;
volatile uint8_t y = 0;
volatile uint8_t rc5HalfbitTransmitionx = 0;
volatile uint16_t rc5CommandArray[3] = {0};
	
	
ISR(INT0_vect)
{		
		TIMSK0 &= ~(1 << TOIE0);
		TCCR0B &= ~(1 << CS01);
		
		
		if(rc5HalfbitTimeAvaible == 0 && interruptExt == 1)
		{
			/*
			rc5HalfbitTimeUndWenig = TCNT0;
			rc5HalfbitTransmition = (rc5HalfbitTime * 256) + rc5HalfbitTimeUndWenig;
			rc5HalfbitTimeAvaible = 1;
			rc5Command |= ((uint16_t)1 << rc5CommandBits);
			rc5LastReadBit = 1;
			rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			*///rc5HalfbitTimeUndWenigx = 0;
		}
		
		rc5HalfbitTimeUndWenigx = TCNT0;		
		rc5HalfbitTransmitionx = (rc5HalfbitTimex * 256) + rc5HalfbitTimeUndWenigx;

		TCNT0 = 0;
		rc5HalfbitTime = 0;
		rc5HalfbitTimex = 0;
		TCCR0B |= (1 << CS01);
		TIMSK0 |= (1 << TOIE0);
		
/*	    
	
		if(!(rc5Command & rc5CommandBits) && rc5HalfbitTimeAvaible == 1 && interruptExt >= 2)
		{
			if(rc5LastReadBit == 1 && rc5HalfbitTransmition <= rc5HalfbitTransmitionx)
			{

				rc5Command |= ((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 1;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
			
			else if(rc5LastReadBit == 1 && rc5HalfbitTransmition >= rc5HalfbitTransmitionx)
			{
				rc5Command &= ~((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 0;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
			
			else if(rc5LastReadBit == 0 && rc5HalfbitTransmition <= rc5HalfbitTransmitionx)
			{
				rc5Command &= ~((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 0;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
			
			else if(rc5LastReadBit == 0 && rc5HalfbitTransmition >= rc5HalfbitTransmitionx)
			{
				rc5Command |= ((uint16_t)1 << rc5CommandBits);
				rc5LastReadBit = 1;
				rc5CommandBits = (rc5CommandBits >> (uint16_t)1);
			}
	
		}	

	if(rc5Command & 0x3000)
	{
		
		rc5CommandBits = 0b10000000000000;
		interruptExt = 0;
		rc5Command = 0b00000000000000;
		rc5HalfbitTimeAvaible = 0;
		//rc5CommandSent = 0;
	}
	
	
	if(rc5CommandBits & 0x1)
	{
			//PORTD ^= (1 << PD6);
		rc5CommandBits = 0x2000;
		interruptExt = 0;
		//rc5Command = (rc5Command >> (uint16_t)1);
		rc5HalfbitTimeAvaible = 0;
		//rc5CommandSent = 0;
	}	
	*/
	
	interruptExt++;
}

ISR(TIMER0_OVF_vect)
{
	
	rc5HalfbitTime++;
	rc5HalfbitTimex++;
	
	
}