/*
 * GccApplication3.c
 *
 * Created: 19.05.2014 22:17:06
 *  Author: Fabio
 */ 
#define F_CPU 16000000L


#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>

double dutyCycleRed = 10;
double dutyCycleGreen = 5;
double dutyCycleBlue = 5;


int main(void)
{
	// PB1 as PWM output for blue led
	// PB2 as PWM output for red led
	DDRB = (1 << DDB1) | (1 << DDB2);
	
	// PD6 as PWM output for green led
	DDRD = (1 << DDD6);
	
	
	TCCR0A = (1 << COM0A1) | (1 << COM0B1) | (1 << WGM00) | (1 << WGM01);
	
	TIMSK0 = (1 << TOIE0);
	
	TCCR1A = (1 << COM1A1) | (1 << COM1B1) | (1 << WGM10) | (1 << WGM11)| (1 << WGM12);
	
	TIMSK1 = (1 << TOIE1);
	
	

	
		
	sei();
	
	TCCR0B = (1 << CS00) | (0 << CS01) | (0 << CS02);

	TCCR1B = (1 << CS10) | (0 << CS11) | (0 << CS12);




while(1)
    {
		_delay_ms(100);
		
		dutyCycleRed += 5;
		dutyCycleGreen += 5;
		dutyCycleBlue += 5;
		
		
    }
}

ISR(TIMER0_OVF_vect)
{
	OCR1B = (dutyCycleRed/100)*255;

	OCR1A = (dutyCycleGreen/100)*255;
		
	OCR0A = (dutyCycleBlue/100)*255;
	
}

ISR(TIMER1_OVF_vect)
{
	OCR1B = (dutyCycleRed/100)*255;

	OCR1A = (dutyCycleGreen/100)*255;
	
	OCR0A = (dutyCycleBlue/100)*255;
	
}