
/*
 * Assembler1.s
 *
 * Created: 26.11.2015 21:16:22
 *  Author: Fabio
 */ 


 #include <avr/io.h>
 #include <avr/interrupt.h>

 #include "IncFile1.h"


 #define _SFR_ASM_COMPAT 1
// #define __SFR_OFFSET 0




 .section .data

  .comm asm_rc5flags, 1








	



 .section .text

		.set rc5halfbittimingflag, 1
	.set rc5bittimingflag, 2
	.set rc5txdoneflag, 4
	.set rc5txtoggleflag, 32

/*
 .global asm_init_sp
 asm_init_sp:

	ldi r16, 0x55
	out _SFR_IO_ADDR(DDRD), r16

 ret

 */

 /*
 .global asm_fun
 asm_fun:
	lds r24, asm_rc5flags
	ldi r25, 0x00

 ret
 */


 .global asm_rc5send
 asm_rc5send:




/*
	push r2
	push r7
	push r8
	push r9
	push r10
	push r16
	push r17

	push YL
	push YH
*/
			

	ldi r16, 13
	mov r7, r16
	mov r16, r24
	
	
	ori r16, 0xC0
	mov r8, r16
 //ldi r16, 0b11111000
	mov r9, r22
	ldi r16, 0b10000000
	mov r10, r16
			ldi r16, 0x80
			out _SFR_IO_ADDR(DDRD), r16

	ldi r16, 0x02
	out _SFR_IO_ADDR(TCCR0A), r16		;tim 0 ctc mode
	ldi r16, 0x02
	out _SFR_IO_ADDR(TCCR0B), r16		;tim 0 1/8 clock source
	ldi r16, 0x02
	sts TIMSK0, r16		;tim 0 comparer match A INT
	ldi r16, 0x04
	out _SFR_IO_ADDR(OCR0A), r16		;tim 0 TOP <- ocr0a

	ldi r16, 0x02
	sts TCCR2A, r16		;tim 2 ctc mode
	ldi r16, 0x01
	sts TCCR2B, r16		;tim 2 clock source
	ldi r16, 0x02
	sts TIMSK2, r16		;tim 2 compare match A INT
	ldi r16, 0x6e
	sts OCR2A, r16		; tim 2 TOP <- ocr2a



	lds r2, asm_rc5flags
	ldi r16 ,0xFB
	and r2, r16
	sts asm_rc5flags, r2

//	lds r2, asm_rc5flags
//	ldi r16, 0xf8
//	eor r2, r16
//	sts asm_rc5flags, r2



//	ldi r16, 0xf8
//	eor r2, r16
//	sts asm_rc5flags, r2
	
/*
	clr r16
	ori r16, !rc5halfbittimingflag
	eor r2, r16
	sts asm_rc5flags, r2
	lds r2, asm_rc5flags
	ori r16, !rc5bittimingflag
	eor r2, r16
	sts asm_rc5flags, r2
	lds r2, asm_rc5flags
	ori r16, !rc5txdoneflag
	eor r2, r16
	sts asm_rc5flags, r2
	clr r17
*/
	sei
	
/*
	pop YH
	pop YL

	pop r17
	pop r16
	pop r10
	pop r9
	pop r8
	pop r7
	pop r2
*/


 ret





  .global TIMER2_COMPA_vect
 	TIMER2_COMPA_vect:

	/*	push r2
		push r4
		push r8
		push r10
		push r15
		push r16*/
		

		in r4, _SFR_IO_ADDR(SREG)
		lds r2, asm_rc5flags
		sbrc r2, 0
		breq rc5send2
//		sbrs r1, 0
//		breq rc5send2
	rc5send1:	;low
		mov r15, r8
		and r15, r10
		cpse r15, r10
		breq rc5send4
		brne rc5send3
	rc5send2:	;high
		mov r15, r8
		com r15
		and r15, r10
		cpse r15, r10
		breq rc5send4
		brne rc5send3
	rc5send3:	;off
		cbi _SFR_IO_ADDR(PORTD), 7
		brne tim2CTCexit
	rc5send4:	;toggle
		in r6, _SFR_IO_ADDR(PORTD)
		ori r16, 128
		eor r6, r16
		out _SFR_IO_ADDR(PORTD), r6
	tim2CTCexit:
		out _SFR_IO_ADDR(SREG), r4

	/*	pop r16
		pop r15
		pop r10
		pop r8
		pop r4
		pop r2
		*/


 reti








  .global TIMER0_COMPA_vect
	TIMER0_COMPA_vect:

	/*
		push r17
		push r16
		push r15
		push r10
		push r9
		push r8
		push r7
		push r4
		push r2
		*/

		in r4, _SFR_IO_ADDR(SREG)		;store status register
		inc r17			;inc conter low byte
		brne rc5Timing2
					/*inc r18			;inc counter high byte
				rc5Timing1:
					cpi r18, 0x00
					brlo tim0CTCexit*/
	rc5Timing2:
		cpi r17, 0xb1// 0xa9    //0xb1
		brlo tim0CTCexit
	rc5Timing3:
		clr r16
		lds r2, asm_rc5flags
		ori r16, rc5halfbittimingflag
		eor r2, r16
		sts asm_rc5flags, r2
		clr r16
		ori r16, rc5bittimingflag
		eor r2, r16
		sts asm_rc5flags, r2
		clr r16
		clr r17
//					clr r18
		sbrs r2, 1
		breq rc5timing4
		breq tim0CTCexit
	rc5timing4:
		lsr r10
		brlo rc5timing5
		dec r7
		tst r7
		brne tim0CTCexit
	done:
		clr r16
		lds r2, asm_rc5flags
		ori r16, rc5txdoneflag
		eor r2, r16
		sts asm_rc5flags, r2
		clr r16
		cbi _SFR_IO_ADDR(PORTD), 7 
		sts TIMSK0, r16
		sts TIMSK2, r16
		cli
		out _SFR_IO_ADDR(SREG), r4	;restore status register

/*
		push r2
		push r4
		push r7
		push r8
		push r9
		push r10
		push r15
		push r16
		push r17
		*/
	reti
	rc5timing5:
		ldi r16, 0x80
		mov r10, r16
		mov r8, r9
	tim0CTCexit:
		out _SFR_IO_ADDR(SREG), r4	;restore status register

/*
		push r2
		push r4
		push r7
		push r8
		push r9
		push r10
		push r15
		push r16
		push r17
		*/
	reti
	


	//.end