/*
 * IncFile1.h
 *
 * Created: 26.11.2015 21:16:37
 *  Author: Fabio
 */ 


#ifndef INCFILE1_H_
#define INCFILE1_H_


#ifdef __cplusplus
extern "C" {
#endif


#ifdef __ASSEMBLER__

#define zeroreg		r0

#define inreg		r2

#define rc5tmpflag		r4
#define rc5hibyte		r5
#define rc5lobyte		r6
#define rc5mask		r7
#define rc5bits		r8

#define rc5lotim		r9
#define rc5hitim		r10
#define rc5decodefalg	r11
#define rc5decodemask	r12
#define rc5decodecomdlo		r21		//r13
#define rc5decodecomdhi		r23		//r14
#define rc5decodebits		r15

#define rc5tmp		r16
#define rc5cnt		r17

#define lotimcnt		r18
#define hitimcnt		r19

#define c_rc5led		r20
#define c_rc5lobyte		r22
#define c_rc5hibyte		r24

#else

#include <stdint.h>



extern volatile uint8_t asm_rc5flags;

register uint8_t rc5decodecomdlo asm("r21");
register uint8_t rc5decodecomdhi asm("r23");

extern void asm_initrc5tim();
extern void asm_rc5send(uint8_t addr, uint8_t comd, uint8_t irled);


void c_rc5send(uint8_t addr, uint8_t comd, uint8_t irled);



#endif


#ifdef __cplusplus
}

#endif


#endif /* INCFILE1_H_ */