/*
 * IrCommDatabaseManegment.h
 *
 * Created: 30.08.2015 21:55:28
 *  Author: Fabio
 */ 


#ifndef IRCOMMDATABASEMANEGMENT_H_
#define IRCOMMDATABASEMANEGMENT_H_


#include <avr/io.h>


#define TAR_DATA			0x100
#define ENV_DATA			0x80
#define COOR_DATA			0x40
#define POS_DATA			0x20
#define LIG_DATA			0x10
#define COL_DATA			0x8
#define SPE_DATA			0x4
#define COM_DATA			0x2

#define TAR_RULE			0x100
#define ENV_RULE			0x80
#define COOR_RULE			0x40
#define POS_RULE			0x20
#define LIG_RULE			0x10
#define COL_RULE			0x8
#define SPE_RULE			0x4
#define COM_RULE			0x2	




class IrCommDatabaseManegment
{
	public:
	
	
	
	IrCommDatabaseManegment();
	
	
	void initialize();
	
	void putNewDataIntoDatabase();
	void convertDatabaseToRc5Command();
	
	void putReceivedIRDataIntoDatabase();
	void convertRc5CommandToDatabase();
	
	void convertDataAndRuleToRc5Command();
	void convertRc5CommandToDataAndRule();
	
	void clearDatabase();
	
	void perpareRequestedData();
	void perpareIncomingData();
	
	void generateRc5FrameArray();
	
	
	static uint8_t newData_TX[12];
	static uint8_t newData_RX[12];
	
// 	static volatile uint32_t DataAndRule_TX;
// 	static volatile uint32_t DataAndRule_RX;
	

	
static volatile int numberOfRequestedData;
static volatile int numberOfRequestedRule;
	
	
	
	
	
	
	
	protected:
	
	private:
	
	
	
	
	
	
	
	
};


extern uint8_t newDataAndRule_TX[3];
extern uint8_t newDataAndRule_RX[3];

extern uint8_t irCommDataFrame_TX[16];
extern uint8_t irCommDataFrame_RX[16];

#endif /* IRCOMMDATABASEMANEGMENT_H_ */