/* 
* srcMott.cpp
*
* Created: 04.10.2015 22:23:56
* Author: Fabio
*/


#include "srcMott.h"

// default constructor
srcMott::srcMott()
{
} //srcMott

// default destructor
srcMott::~srcMott()
{
} //~srcMott

void srcMott::configIO(int ddr, int pin, int mode)
{
	switch (mode)
	{
		case OUTPUT:
				switch (ddr)
				{
					case DDR_B:
							DDRB |= (1 << pin);
						break;
					case DDR_C:
							DDRC |= (1 << pin);
						break;
					case DDR_D:
							DDRD |= (1 << pin);
						break;	
				}
			break;
		case INPUT:
				switch (ddr)
				{
					case DDR_B:
							DDRB &= ~(1 << pin);
						break;
					case DDR_C:
							DDRC &= ~(1 << pin);
						break;
					case DDR_D:
							DDRD &= ~(1 << pin);
						break;
				}
			break;
	}
}

void srcMott::valueIO(int port, int pin, int value)
{
	switch (value)
	{
		case HIGH:
				switch (port)
				{
					case PORT_B:
							PORTB |= (1 << pin);
						break;
					case PORT_C:
							PORTC |= (1 << pin);
						break;
					case PORT_D:
							PORTD |= (1 << pin);
						break;
				}
			break;
		case LOW:
				switch (port)
				{
					case PORT_B:
							PORTB &= ~(1 << pin);
						break;
					case PORT_C:
							PORTC &= ~(1 << pin);
						break;
					case PORT_D:
							PORTD &= ~(1 << pin);
						break;
				}
			break;
	}
}

void srcMott::configADC(int adcAREF, int adcCS)
{
	
}

uint16_t srcMott::valueADC(uint8_t channel)
{
	
}


