/*
 * RobotMain.cpp
 *
 * Created: 11.08.2015 16:25:30
 *  Author: Fabio
 */ 


#include <avr/io.h>
#define F_CPU 8000000UL
#include <avr/delay.h>


#include "specificLibMain/RobotStatusLightHardwareControl/StatusLight/StatusLight.h"
#include "specificLibMain/RobotIrCommHardwareControl/IrComm/IrComm.h"
#include "specificLibMain/RobotIrCommHardwareControl/IrComm/IrCommDatabaseManegment.h"
#include "specificLibMain/RobotIrCommHardwareControl/IrComm/DatabaseManegmentFlags.h"

	StatusLight sl;
	StatusLightHardwareControl rhc;
	
	IrComm ir;
	IrCommandHardwareControl irh;

	IrCommDatabaseManegment irdm;
	DatabaseManegmentFlags mdmf;
	
int main(void)
{

	rhc.initialize();
 
 	sl.initialize();
	
 	irh.initialize();
 	
 	ir.initialize();
	 
	mdmf.initialize();
	 
// 	 mdmf.setDatabaseFlag_TX();
// 
// 	 
// 	 
// 	 if (mdmf.checkDatabaseFlag_TX())
// 	 {
// 		 sl.setStatusLightOk();
// 	 }
	 
	 
	 
	 
// 	 sl.setStatusLightOk();
// 	 
// 	 sl.setRgbLedCustom(191, 223, 243);
// 	 
// 	 irdm.putNewDataIntoDatabase();
// 	 irdm.convertDatabaseToRc5Command();
// 	 
// // 	 ir.generateRc5Frame(IR_COMM_GLOBAL_ID, irCommDataFrame_TX[5]);
// // 	 
// // 	 ir.sendIrframe(IR_LED_FRONT_MIDDLE_PORT_BIT);
// 	 
// 		  
// 	 ir.irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_NEW_DATA_AVAILABLE, irCommDataFrame_TX);
// 	 
// 
// 	 if (irCommDataFrame_TX[0] == 63)
// 	 {
// 		 sl.setStatusLightFail();
// 	 }
// 	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
// 	
//  	rhc.setTimer0Off();
//  	rhc.setTimer1Off();
//  	rhc.setTimer2Off();
	
//	sl.setRgbLedCostomOff();
	
	
// 	if (rhc.getInitializeHardwareState() == ON_OK)
// 	{
// 	statusLight.setStatusLightOk();
// 	_delay_ms(1000);
// 	}
// 	else
// 	{
// 			statusLight.setStatusLightFail();
// 			_delay_ms(1000);
// 	}
// 
// 
// 
// 	statusLight.setStatusLedIrCommOk();
// 	_delay_ms(1000);
// 	statusLight.setStatusLedIrCommFail();
// 	_delay_ms(1000);
// 	statusLight.setStatusLedGetIrDistance();
// 	_delay_ms(1000);
// 	statusLight.setStatusLedIrDistanceOk();

//IrComm::rc5Command = 0b11110001111100;

// rhc.setTimer0Off();
// rhc.setTimer1Off();
// rhc.setTimer2Off();
// uint8_t rc5cody[12] = { 0 };
// 
// 
// rc5cody[0] = 0b111111;



//ir.dataBaseFlags.newColorDataAvailable = 0;


// IrComm::dataBaseFlags newDataFlags;
// 
// 
// newDataFlags.newColorDataAvailable = 0;


// 								IR /* 15    14    13    12    11    10      9     8     7     6     5     4     3     2     1     0       */
// 								/*    |     |     |     |     |     |       |     |     |     |     |     |     |     |     |     |      */	
// 		IrComm::irCommSendData_00 =									  0b1010111100000000111111110000000011110000111100001111000011110000;
// 		IrComm::irCommSendData_01 = 0b01011000111111110000000011111110;
 				/*                    |       |       |       |         |       |       |       |       |       |       |       |        */
		 //						Byte /* 11	  10	  9		  8			7		6		5		4		3		2		1		0	       */
   
   
   		//externIrCommRc5Data[11] = 0b10101010;
   		//externIrCommDataBytes();
   
//    uint8_t arry[12] = { 0 };
// 	   arry[0] = 0b10101010;
// 	   arry[1] = 0b10101010;
// 	   arry[2] = 0b10101010;
// 	   arry[11] = 0b11110101;
// 	   


   
/*

	ir.getExternIrCommRc5Data(1);
   
		*/

// 	 sl.setStatusLightOk();
// 	 
// 	 sl.setRgbLedCustom(186, 223, 243);
// 	 
// 	 sl.setStatusLightFail();
	 
	 
   //ir.initializeIrmp();
   irmp_init ();
   irh.setIrmpTimer1Config();
   irh.setIrmpTimer1On();
   
IRMP_DATA mp;
    while(1)
    {
		
// 	ir.irCommSendMyId(IR_LED_FRONT_MIDDLE_PORT_BIT);
// 	 
// 	_delay_ms(1000);





if (irmp_get_data(&irmp) == 1)
{
	//sl.setStatusLedIrDistanceOk();
// 	   irh.setIrmpTimer1Config();
// 	   irh.setIrmpTimer1On();



if (irmp.flags == 1)
{
	sl.setStatusLightFail();
}


if (irmp.address == 0)
{
	sl.setStatusLightOk();
}

if (irmp.command == 0)
{
	sl.setStatusLedIrCommOk();
}



}





_delay_ms(100);




// 	int i = 0;
// 	int j = 0;
// 	int timeout = 3;
// 	uint8_t masterId = 0;
// 	uint8_t myId = 0;
// 	uint8_t opponentIdRX = 0;
// 	uint8_t opponentIdTX = 0;
// 	uint8_t requestedData = 0;
// 
// 	ir.irCommSendMyId(IR_LED_FRONT_MIDDLE_PORT_BIT);	/*	GLOBAL ID		MY ID 	*/
// 	
// 	ir.initializeIrmp();
// 	
// 	
// 
// 		ir.getIrmpData();
// 		
// 		masterId = irmp.address;
// 		/*	requested opponent id	*/
// 		if (masterId == IR_COMM_GLOBAL_ID)
// 		{	sl.setStatusLedIrCommOk();
// 			opponentIdRX = irmp.command;
// 			ir.irCommSendDataLable(IR_LED_FRONT_MIDDLE_PORT_BIT, opponentIdRX, IR_COMM_MY_ID);
// 			ir.initializeIrmp();
// 			mdmf.setOppenentIdAvailable();
// 			/*			irch.setIrmpTimer1InitialValue();*/
// 			}	/*	response from opponent	*/
// 			else if (masterId == IR_COMM_MY_ID)
// 			{
// 				opponentIdTX = irmp.command;
// 			}
// 			// 		else if (i < timeout)
// 			// 		{	isl.setStatusLedIrCommFail();
// 			// 			//break;
// 			// 		}
// 			/*	IRMP get oppenent id*/
// 			//		i++;
// 			
// 			irh.setIrmpTimer1InitialValue();



















	 
/*
	 irdm.putNewDataIntoDatabase();
	 irdm.convertDatabaseToRc5Command();
	 
	 
	 ir.irCommSendDataString(IR_LED_FRONT_MIDDLE_PORT_BIT, IR_COMM_GLOBAL_ID, IR_COMM_NEW_DATA_AVAILABLE, irCommDataFrame_TX);
	 

	 if (irCommDataFrame_TX[0] == 63)
	 {
		 sl.setStatusLightFail();
	 }
	 */
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
	 
/*
   		if (IrComm::irCommSendData_01 & 0x80)
   		{
	   		sl.setStatusLightOk();
   		}
		   
   		if (!(IrComm::irCommSendData_01 & 0x80))
   		{
	   		sl.setStatusLightFail();
   		}
*/

//    
//    
//    if (s->newTargetDataAvailable == 0)
//    {
// 	   sl.setStatusLightOk();
//    }
//    


/*IrComm::irCommSendData_00 = 0b111000111001111010111011111100111101111110111111;*/

		

/*externIrCommDataArray (&s);*/
		
		
/*
		for (int i = 0; i < 12; i++)
		{
			/ *IrComm::getExternIrCommRc5Data(&arry[i], i);* /externIrCommDataArray(arry, i);
		}
		
		externIrCommDataBytes();*/
	/*
		ir.generateRc5DataFrame(IrComm::irCommSendData_00, IrComm::irCommSendData_01);*/
		
		
		
		/*IrComm::arr(arry);*/
		
		
//		ir.generateRc5DataBytes(IrComm::irCommSendData_00, IrComm::irCommSendData_01);
		
/*		setIrCommDataFrame(rc5cody[0]);*/
		
/*		externIrCommRc5Data[0] = 0b111111;*/
		
		
		
		
		
		
/*
		
		IrComm::getExternIrCommRc5Data(arry, IR_COMM_TARGET_DATA_AVAILABLE);
				
		if (ir.irCommSendData[14] & 0x20)
		{
			sl.setStatusLightOk();
		}
_delay_ms(500);*/
		
		
		
		
		
		
		
		
		
		
// 		if (IrComm::rc5Code == white)
// 		{
// 			sl.setStatusLightOk();
// 		}
// 		
// 		if ((ir.generateRc5Command(white)) == white)
// 		{
// 			sl.setStatusLightFail();
// 		}
		
		
		
		
		
// 		
// 		if (IrComm::rc5Code == white)
// 		{
// 			//sl.setStatusLightOk();
// 		}
// 		
// 		if ((ir.generateRc5Command(white)) == 0b111111)
// 		{
// 			sl.setStatusLightOk();
// 		}

		
		
		
// 		if (!(IrComm::rc5Command & 0x2000))
// 		{
// 			//sl.setStatusLightFail();
// 		}
		
//ir.generateRc5Frame(IR_COMM_MY_ID, white);
		
// 		uint8_t id = 0b10001;
// 		uint8_t da = 0b111111;
		
/*		rc5cody = IrComm::generateRc5Frame(IR_COMM_MY_ID, white);*/
		
		
	
	
	
	
	
		
// 		
// 		ir.irCommSendMyId(IR_LED_FRONT_MIDDLE_PORT_BIT);
// 		
// 		if (IrComm::rc5Command & 0x8)          /*11010001111111 &*/
// 		{														/*00000000100000	*/
// 			sl.setStatusLightOk();
// 		}else
// 		{
// 			sl.setStatusLightFail();
// 		}
// 		 _delay_ms(1000);
		
		
		
		
		
		
		 
		 
		 
		 
		//rc5cody = ir.generateRc5Frame(IR_COMM_MY_ID, white);
		
// 	
// 		rc5cody = ir.generateRc5Command(white);
		
		
// 		if (IrComm::rc5Code == white)
// 		{
// 			sl.setStatusLedIrCommOk();
// 		}

				
/*		IrComm::rc5Command = 0b11110001111100;*/
/*		ir.generateRc5Frame(IR_COMM_GLOBAL_ID, white);*/

		//rc5cody = ir.generateRc5Frame(IR_COMM_GLOBAL_ID, white);

/*		IrComm::rc5Command = 0b11110001111111;*/














// 		if (rc5cody == 0b11110001111111)
// 		{
// 			sl.setStatusLedIrCommOk();
// 		}
// 			
// 		IrComm::rc5Command = 0b11110001111100;
// 		ir.irCommSendMyId(IR_LED_FRONT_MIDDLE_PORT_BIT);
// 		_delay_ms(1000);
// 		
// 
// 		sl.setStatusLightOk();
// 		_delay_ms(1000);
// 		sl.setStatusLightFail();
// 		_delay_ms(1000);
// 		sl.setStatusLedIrDistanceOk();
// 		_delay_ms(1000);
// 		sl.setStatusLedGetIrDistance();
// 		_delay_ms(1000);
// 		sl.setStatusLedIrCommOk();
// 		_delay_ms(1000);
// 		sl.setStatusLedIrCommFail();
// 		_delay_ms(1000);
// 
// 		
// 		
// 		
// 		
// 		IrComm::rc5Command = 0b11110001111101;
// 		ir.irCommSendMyId(IR_LED_FRONT_MIDDLE_PORT_BIT);
// 		_delay_ms(1000);
// 		
// 
// 		
// 		IrComm::rc5Command = 0b11110001111110;
// 		ir.irCommSendMyId(IR_LED_FRONT_MIDDLE_PORT_BIT);
// 		_delay_ms(1000);
		
		
		
		
		
		
		
		
    }
}












// ISR(TIMER2_COMPA_vect)
// {
// 	rhc.timer2Value++;
// 	sl.timerValue++;
// // 		if (rhc.timer2Value <= 5000)
// // 		{
// // 			sl.setRgbLedCostumGreen(245);
// // 		}else
// // 		{
// // 			sl.setRgbLedCostomOff();
// // 		}
// 	
// 	
// }














// while(1)
// {
// 	sl.setRgbLedLongPulse('r',1500);
// }

//   	sl.setRgbLedLongPulse('r',11500);
//    	sl.setRgbLedLongPulse('g',11500);
//    	sl.setRgbLedLongPulse('b',11500);


// sl.setRgbLedCostumRed(254);
// sl.setRgbLedCostomRedOff();

/*cli();*/




// if (rhc.getInitializeHardwareState() == ON_OK)
// {

// 	if (rhc.timer2Value >= 0 && rhc.timer2Value <= 1000)
// 	{
// 		sl.setRgbLedCostumGreen(245);
// 	}
// 	if (rhc.timer2Value >= 1001 && rhc.timer2Value <= 2100)
// 	{
// 		sl.setRgbLedCostomOff();
// 	}
















//sl.setRgbLedCustom(254,254,254);


//  	sl.setRgbLedCostomOff();
// 	sl.setRgbLedCostumRed(154);
// 	sl.setRgbLedCostumGreen(125);
// 	sl.setRgbLedCostumRed(163);
// 		sl.setRgbLedCostomRedOff();

// 			sl.setRgbLedCostumRed(247);
// 			sl.setRgbLedCostumGreen(247);
// 			sl.setRgbLedCostumBlue(247);
// 			sl.setRgbLedCostomGreenOff();
// 			sl.setRgbLedCostomRedOff();
// 			sl.setRgbLedCostomBlueOff();
// 			sl.setRgbLedCostumRed(154);
// 			sl.setRgbLedCostumGreen(154);
// 			sl.setRgbLedCostumBlue(154);
//  			sl.setRgbLedCostomGreenOff();
//  			sl.setRgbLedCostomRedOff();
//  			sl.setRgbLedCostomBlueOff();
//

// 	sl.setRgbLedCostumGreen(227);
// 	sl.setRgbLedCostomGreenOff();
// 	sl.setRgbLedCostumBlue(227);
// 	sl.setRgbLedCostomBlueOff();
// 	sl.setRgbLedCostumRed(227);
// 	sl.setRgbLedCostomGreenOff();
/*	sl.setRgbLedCostomOff();*/
//sl.setRgbLedCustom(254,254,254);
/*	sl.setRgbLedCustom(254,254,254);*/


// 		sl.setRgbLedOff();
// 	sl.setRgbLedCustom(235,235,235);
// 	sl.setRgbLedCostomOff(sl.rgbLedCostomOff);


/*	sl.setRgbLedCostomOff(sl.rgbLedCostomOff);*/

//sl.setRgbLedCostumRed(222);


// 	enum {
// 		sl.setRgbLedPurple() = 10,
// 		sl.setRgbLedTurquoise(),
// 		sl.setRgbLedYellow(),
// 		sl.setRgbLedRed(),
// 		sl.setRgbLedGreen(),
// 		sl.setRgbLedBlue()
//
// 	}statusLight;

//rhc.setRgbLedBlue(RGB_LED_BLUE_OUTPUT, RGB_LED_BLUE_ON);

// 	StatusLightHardwareControl rhc;
//
//
//
//
// 	rhc.initialize();
// 	rhc.setRgbLedRed(RGB_LED_RED_OUTPUT, RGB_LED_RED_ON);
// 	rhc.setRgbLedBlue(RGB_LED_BLUE_OUTPUT, RGB_LED_BLUE_OFF);
// 	rhc.setRgbLedGreen(RGB_LED_GREEN_OUTPUT, RGB_LED_GREEN_ON);
//
//
//
// 	if (rhc.getRgbLedGreen() == RGB_LED_STATE_GREEN_ON)
// 	{
// 		rhc.setRgbLedRed(RGB_LED_RED_OUTPUT, RGB_LED_RED_OFF);
// 		rhc.setRgbLedBlue(RGB_LED_BLUE_OUTPUT, RGB_LED_BLUE_ON);
// 	}
// 	else if (rhc.getRgbLedGreen() == RGB_LED_STATE_GREEN_OFF)
// 	{
// 		rhc.setRgbLedBlue(RGB_LED_BLUE_OUTPUT, RGB_LED_BLUE_OFF);
// 		rhc.setRgbLedRed(RGB_LED_RED_OUTPUT, RGB_LED_RED_ON);
// 	}
//


//rhc.setTimer2On();


















//rhc.setTimer2Off();
//sl.setRgbLedLongPulse('r',11500);

// 			sl.currenttimerValue = sl.timerValue;
//
// 			if(sl.currenttimerValue - sl.previoustimerValue < 1000)
// 			{
// 				sl.previoustimerValue = sl.currenttimerValue;
//
// 				sl.setRgbLedCostumRed(254);
// 				}else{sl.setRgbLedCostumBlue(254);}
//
// 		while (!(sl.setStatusLightOk()))
// 		{
// 			sl.setStatusLightOk();
// 		}
// 			sl.setRgbLedCustom(197,197,247);
// 			_delay_ms(1000);
// 			sl.setRgbLedCostomOff();
// 			_delay_ms(100);
// 			sl.setRgbLedCostumRed(237);
// 			_delay_ms(1000);
// 			sl.setRgbLedCostomRedOff();
// 			_delay_ms(100);
// 			sl.setRgbLedCostumGreen(237);
// 			_delay_ms(1000);
// 			sl.setRgbLedCostomGreenOff();
// 			_delay_ms(100);
// 			sl.setRgbLedCostumBlue(237);
// 			_delay_ms(1000);
// 			sl.setRgbLedCostomBlueOff();
// 			_delay_ms(100);



// 				sl.setRgbLedCostumRed(254);
// 				sl.setRgbLedCostumGreen(254);
// 				sl.setRgbLedCostumBlue(254);
// 				sl.setRgbLedCostomGreenOff();
// 				sl.setRgbLedCostomRedOff();
// 				sl.setRgbLedCostomBlueOff();



//TODO:: Please write your application code






