/*
 * IrDataFlags.h
 *
 * Created: 27.08.2015 22:08:16
 *  Author: Fabio
 */ 


#ifndef IRDATAFLAGS_H_
#define IRDATAFLAGS_H_
#include <avr/io.h>



class IrDataFlags
{
	public:
		
		
		
		IrDataFlags();
		
		void initialize();
		
		

		
		static uint64_t globalFlags;
		
		
		
		
		
		
	protected:
	
	private:
};

		
		
		
		


		#define SET_FLAG	1
		#define CLEAR_FLAG	0
		
		extern void structInitialValue();
		
		extern void selectData(uint8_t data);
		
		extern void selectNewData();
		extern void checkNewDataAvailable();
		extern void getNewData();
		
		extern void selectTargetDataAvailable();
		extern void checkTargetDataAvailable();
		extern void getTargetDataAvailable();
		
		extern void selectEnvironmentDataAvailable();
		extern void checkEnvironmentDataAvailable();
		extern void getEnvironmentDataAvailable();
				
		extern void selectCoordinatesDataAvailable();
		extern void checkCoordinatesDataAvailable();
		extern void getCoordinatesDataAvailable();

		extern void selectPositionDataAvailable();
		extern void checkPositionDataAvailable();
		extern void getPositionDataAvailable();

		extern void selectLightDataAvailable();
		extern void checkLightDataAvailable();
		extern void getLightDataAvailable();

		extern void selectColorDataAvailable();
		extern void checkColorDataAvailable();
		extern void getColorDataAvailable();

		extern void selectSpeedDataAvailable();
		extern void checkSpeedDataAvailable();
		extern void getSpeedDataAvailable();

		extern void selectCompassDataAvailable();
		extern void checkCompassDataAvailable();
		extern void getCompassDataAvailable();
		
		extern void selectReserveDataAvailable();
		extern void checkReserveDataAvailable();
		extern void getReserveDataAvailable();
		
		extern void selectNoNewDataAvailable();
		extern void checkNoNewDataAvailable();
		extern void getNoNewDataAvailable();
		


		
		extern void externDataAvailableFlag_SET();
		extern void externDataAvailableFlag_CLEAR();
		
		extern uint8_t externDataAvailableFlag();
		//extern uint8_t externDataAvailableFlag();
		
		extern uint8_t externGetDataFlag_SET();
		extern uint8_t externGetDataFlag_CLEAR();
		
				
		
		   typedef struct newDataAvailableFlags
		   {
			   uint16_t newDataAvailable:1;
			   uint16_t newTargetDataAvailable:1;
			   uint16_t newEnvironmentDataAvailable:1;
			   uint16_t newCoordinatesDataAvailable:1;
			   uint16_t newPositionDataAvailable:1;
			   uint16_t newLightDataAvailable:1;
			   uint16_t newColorDataAvailable:1;
			   uint16_t newSpeedDataAvailable:1;
			   uint16_t newCompassDataAvailable:1;
			   uint16_t newReserveDataAvailable:1;
			   
			   uint16_t noNewDataAvailable:1;
			   
		   }newDataAvailableFlags_t;
		   
		   
		   typedef struct getDataFlags
		   {
			   uint16_t getData:1;
			   uint16_t getTargetData:1;
			   uint16_t getEnvironmentData:1;
			   uint16_t getCoordinatesData:1;
			   uint16_t getPositionData:1;
			   uint16_t getLightData:1;
			   uint16_t getColorData:1;
			   uint16_t getSpeedData:1;
			   uint16_t getCompassData:1;
			   uint16_t getReserveData:1;
			   
			   uint16_t getNoData:1;
			   
		   }getDataFlags_t;
		   
		   
		    /*typedef struct newDataAvailableFlags_t*/;

			
			
				typedef struct st
				{
					uint8_t newData:1;
					
				}str;
	
//  	extern flag;



/*newDataAvailableFlags_t _newDataAvailableFlags = {0,0,0,0,0,0,0,0,0,0,0};*/

#endif /* IRDATAFLAGS_H_ */