/*
 * RobotHardwareControl.cpp
 *
 * Created: 08.08.2015 21:50:36
 *  Author: Fabio
 */ 

#include "RobotHardwareControl.h"





RobotHardwareControl::RobotHardwareControl(){}



void RobotHardwareControl::initialize()
{
	setIrLedFrontMiddle(IR_LED_FRONT_MIDDLE_OUTPUT, IR_LED_FRONT_MIDDLE_OFF);
	setIrLedFrontRight(IR_LED_FRONT_RIGHT_OUTPUT, IR_LED_FRONT_RIGHT_OFF);
	setIrLedBackRight(IR_LED_BACK_RIGHT_OUTPUT, IR_LED_BACK_RIGHT_OFF);
	setIrLedBackMiddle(IR_LED_BACK_MIDDLE_OUTPUT, IR_LED_BACK_MIDDLE_OFF);
	setIrLedBackLeft(IR_LED_BACK_LEFT_OUTPUT, IR_LED_BACK_LEFT_OFF);
	setIrLedFrontLeft(IR_LED_FRONT_LEFT_OUTPUT, IR_LED_FRONT_LEFT_OFF);
	
	setRgbLedRed(RGB_LED_RED_OUTPUT, RGB_LED_RED_OFF);
	setRgbLedGreen(RGB_LED_GREEN_OUTPUT, RGB_LED_GREEN_OFF);
	setRgbLedBlue(RGB_LED_BLUE_OUTPUT, RGB_LED_BLUE_OFF);
	
}


uint8_t RobotHardwareControl::getIrLedFrontMiddle()
{
// 	irLedState |= (PIND & PORTD7);
// 	return irLedState;
}
void RobotHardwareControl::setIrLedFrontMiddle(uint8_t irLedFrontMiddle, uint8_t irLedFrontMiddleValue){}
	
uint8_t RobotHardwareControl::getIrLedFrontRight()
{
// 	irLedState |= (PIND & PORTD5);
// 	return irLedState;
}
void RobotHardwareControl::setIrLedFrontRight(uint8_t irLedFrontRight, uint8_t irLedFrontRightValue){}
	
uint8_t RobotHardwareControl::getIrLedBackRight()
{
// 	irLedState |= (PIND & PORTD4);
// 	return irLedState;
}
void RobotHardwareControl::setIrLedBackRight(uint8_t irLedBackRight, uint8_t irLedBackRightValue){}
	
uint8_t RobotHardwareControl::getIrLedBackMiddle()
{
// 	irLedState |= (PIND & PORTD3);
// 	return irLedState;
}
void RobotHardwareControl::setIrLedBackMiddle(uint8_t irLedFrontMiddle, uint8_t irLedBackMiddleValue){}
	
uint8_t RobotHardwareControl::getIrLedBackLeft()
{
// 	irLedState |= (PIND & PORTD1);
// 	return irLedState;
}
void RobotHardwareControl::setIrLedBackLeft(uint8_t irLedFrontMiddle, uint8_t irLedBackLeftValue){}
	
uint8_t RobotHardwareControl::getIrLedFrontLeft()
{
// 	irLedState |= (PIND & PORTD0);
// 	return irLedState;
}
void RobotHardwareControl::setIrLedFrontLeft(uint8_t irLedFrontMiddle, uint8_t irLedFrontLeftValue){}





uint8_t RobotHardwareControl::getRgbLedRed()
{
	if (!(RB_LED_PORT & RGB_LED_R_PORT_BIT))
	{
		rgbLedState_u.rgbLedStateRed = RGB_LED_STATE_ON;
	}
	else if (RB_LED_PORT & RGB_LED_R_PORT_BIT)
	{
		rgbLedState_u.rgbLedStateRed = RGB_LED_STATE_OFF;
	}

	return rgbLedState_u.rgbLedStateRed;
}

void RobotHardwareControl::setRgbLedRed(uint8_t rgbLedRed, uint8_t rgbLedRedValue){}


uint8_t RobotHardwareControl::getRgbLedGreen()
{
	if (!(G_LED_PORT & RGB_LED_G_PORT_BIT))
	{
		rgbLedState_u.rgbLedStateGreen = RGB_LED_STATE_ON;
	}
	else if (G_LED_PORT & RGB_LED_G_PORT_BIT)
	{
		rgbLedState_u.rgbLedStateGreen = RGB_LED_STATE_OFF;
	}

	return rgbLedState_u.rgbLedStateGreen;
}
void RobotHardwareControl::setRgbLedGreen(uint8_t rgbLedGreen, uint8_t rgbLedGreenValue){}


uint8_t RobotHardwareControl::getRgbLedBlue()
{	
	if (!(RB_LED_PORT & RGB_LED_B_PORT_BIT))
	{
		rgbLedState_u.rgbLedStateBlue = RGB_LED_STATE_ON;
	}
	else if (RB_LED_PORT & RGB_LED_B_PORT_BIT)
	{
		rgbLedState_u.rgbLedStateBlue = RGB_LED_STATE_OFF;
	}

	return rgbLedState_u.rgbLedStateBlue;
}
void RobotHardwareControl::setRgbLedBlue(uint8_t rgbLedBlue, uint8_t rgbLedBlueValue){}





uint8_t RobotHardwareControl::getIrTransistorFrontMiddle(){}
void RobotHardwareControl::setIrTransistorFrontMiddle(uint8_t irTransistorFrontMiddle){}
uint8_t RobotHardwareControl::getIrTransistorFrontRight(){}
void RobotHardwareControl::setIrTransistorFrontRight(uint8_t irTransistorFrontRight){}
uint8_t RobotHardwareControl::getIrTransistorBackRight(){}
void RobotHardwareControl::setIrTransistorBackRight(uint8_t irTransistorBackRight){}
uint8_t RobotHardwareControl::getIrTransistorBackMiddle(){}
void RobotHardwareControl::setIrTransistorBackMiddle(uint8_t irTransistorBackMiddle){}
uint8_t RobotHardwareControl::getIrTransistorBackLeft(){}
void RobotHardwareControl::setIrTransistorBackLeft(uint8_t irTransistorBackLeft){}
uint8_t RobotHardwareControl::getIrTransistorFrontLeft(){}
void RobotHardwareControl::setIrTransistorFrontLeft(uint8_t irTransistorFrontLeft){}





uint8_t RobotHardwareControl::getDefaultHardwareState()
{
	 
}
uint8_t RobotHardwareControl::getSoftwareHardwareState(){}