/* 
* motorControlHardwareSetup.h
*
* Created: 09.10.2015 18:02:57
* Author: Fabio
*/


#ifndef __MOTORCONTROLHARDWARESETUP_H__
#define __MOTORCONTROLHARDWARESETUP_H__

#include <avr/io.h>

#define MT_LF		0
#define MT_RG		1


#define MD_ST		0
#define	MD_FR		1
#define	MD_BC		2
#define	MD_BR		3
#define	MD_FR_PWM	4
#define MD_BC_PWM	5
#define MD_FR_VREF	6
#define MD_BC_VREF	7


class motorControlHardwareSetup
{
//variables
public:
protected:
private:

//functions
public:
	motorControlHardwareSetup();
	~motorControlHardwareSetup();
	
	void motorControlHardwareSetupInit();
	
	void motorDirectionHardwareSetupConfigIO(int8_t motor, int8_t motorDriverMode);
	void motorDecodeHardwareSetupConfigAdc();
	void motorControlHardwareSetupConfigTimer0();
	void motorControlHardwareSetupConfigTimer1();
	void motorControlHardwareSetupConfigTimer2();
	
	
protected:
private:
	motorControlHardwareSetup( const motorControlHardwareSetup &c );
	motorControlHardwareSetup& operator=( const motorControlHardwareSetup &c );

}; //motorControlHardwareSetup

#endif //__MOTORCONTROLHARDWARESETUP_H__
