/*
 * asm.asm
 *
 *  Created: 20.10.2015 00:31:55
 *   Author: Fabio
 */ 

    .include "m328pdef.inc"
	
	   .dseg
 .org $100
 rdct: .byte 2
 grct: .byte 2
 blct: .byte 2
 psct: .byte 2
 spct: .byte 2

	.cseg
	.org $70

	.macro ckr
	ldi r17, 0
	cpse @0, r17
	cpse @1, r17
	breq rof
	.endmacro

	.macro ckg
	ldi r17, 0
	cpse @0, r17
	cpse @1, r17
	breq gof
	.endmacro

	.macro ckb
	ldi r17, 0
	cpse @0, r17
	cpse @1, r17
	breq bof
	.endmacro

	.macro blpwm
	ldi r16, @0
	sts ocr1al, r16
	.endmacro

	.macro rdpwm
	ldi r16, @0
	sts ocr1bl, r16
	.endmacro

	.macro grpwm
	ldi r16, @0
	out ocr0a, r16
	.endmacro


	.macro prof
	ldi r16, 0
	sts ocr1bl, r16
	.endmacro

	.macro pgof
	ldi r16, 0
	out ocr0a, r16
	.endmacro

	.macro pbof
	ldi r16, 0
	sts ocr1al, r16
	.endmacro


	.macro sutm2
	ldi r16, 0x02
	sts tccr2a, r16
	ldi r16, 0x03
	sts tccr2b, r16
	ldi r16, 0x02
	sts timsk2, r16
	ldi r16, 250
	sts ocr2a, r16
	.endmacro

	.macro sutm1
	ldi r16, 0xf1
	sts tccr1a, r16
	ldi r16, 0x01
	sts tccr1b, r16
	.endmacro

	.macro sutm0
	ldi r16, 0xc1
	out tccr0a, r16
	ldi r16, 0x01
	out tccr0b, r16
	.endmacro

	.macro ldrt
	ldi r24, low(@0)
	ldi r25, high(@0)
	.endmacro

	.macro ldgt
	ldi r26, low(@0)
	ldi r27, high(@0)
	.endmacro

	.macro ldbt
	ldi r28, low(@0)
	ldi r29, high(@0)
	.endmacro

	.macro blue
	.equ bt = @0
	.equ bpw = @1
		sutm2
		sutm1
		ldbt bt
		blpwm bpw
	.endmacro
	
	.macro red
	.equ rt = @0
	.equ rpw = @1
		sutm2
		sutm1
		ldrt rt
		rdpwm rpw
	.endmacro

	.macro green
	.equ gt = @0
	.equ gpw = @1
		sutm2
		sutm0
		ldgt gt
		gdpwm gpw
	.endmacro

	.macro gren
		sutm2
		sutm0
		ptpntct @0, grct
		grpwm @1
	.endmacro

	.macro reed
		sutm2
		sutm1
		ptpntct @0, rdct
		rdpwm @1
	.endmacro

	.macro bluee
		sutm2
		sutm1
		ptpntct @0, blct
		blpwm @1
	.endmacro

	.macro macr
	
	.endmacro

	.macro paus
		sutm2
		sutm1
		sutm0
		ptpntct @0, psct
		ptpntct @1, spct
		ldi r17, 0
		in r16, ocr0a
		cp r16, r17
		;breq mar
		cpse r16, r17
		rdpwm @2
		
		grpwm @3
		blpwm @4
	.endmacro



	.macro ptpntct
	ldi r24, low(@0)
	ldi r25, high(@0)
	ldi xl, low(@1)
	ldi xh, high(@1)
	st x+, r24
	st x, r25
	
	.endmacro

	.macro dcpntct
	ldi xl, low(@0)
	ldi xh, high(@0)
	ld r24, x+
	ld r25, x
	sbiw r25:r24, 1
	;ckr r25,r24
	;chck @0
	;ckb r25,r24
	stpntct @0
	.endmacro

	.macro stpntct
	ldi xl, low(@0)
	ldi xh, high(@0)
	st x+, r24
	st x, r25
	
	.endmacro


	.macro chck
	.if @0 == rdct
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq rof
	.elif @0 == grct
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq gof
	.elif @0 == blct
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq bof
	.endif


	.endmacro


		.macro dcpntctr
	ldi xl, low(rdct)
	ldi xh, high(rdct)
	ld r24, x+
	ld r25, x
	sbiw r25:r24, 1
	stpntct rdct
	ckrr rdct
	.endmacro

		.macro dcpntctg
	ldi xl, low(grct)
	ldi xh, high(grct)
	ld r24, x+
	ld r25, x
	sbiw r25:r24, 1
	stpntct grct
	ckgg grct
	.endmacro

		.macro dcpntctb
	ldi xl, low(blct)
	ldi xh, high(blct)
	ld r24, x+
	ld r25, x
	sbiw r25:r24, 1
	stpntct blct
	ckbb blct
	.endmacro

		.macro dcpntctp
	ldi xl, low(psct)
	ldi xh, high(psct)
	ld r24, x+
	ld r25, x
	sbiw r25:r24, 1
	stpntct psct
	ckrr spct
	.endmacro

		.macro dcpntcts
	ldi xl, low(spct)
	ldi xh, high(spct)
	ld r24, x+
	ld r25, x
	sbiw r25:r24, 1
	stpntct spct
	ckgg spct
	.endmacro


	.macro ckrr
	ldi xl, low(@0)
	ldi xh, high(@0)
	ld r24, x+
	ld r25, x
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq rof
	.endmacro

	.macro ckgg
	ldi xl, low(@0)
	ldi xh, high(@0)
	ld r24, x+
	ld r25, x
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq gof
	.endmacro

	.macro ckbb
	ldi xl, low(@0)
	ldi xh, high(@0)
	ld r24, x+
	ld r25, x
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq bof
	.endmacro

		.macro ckp
	ldi xl, low(@0)
	ldi xh, high(@0)
	ld r24, x+
	ld r25, x
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq of
	.endmacro

	.macro cks
	ldi xl, low(@0)
	ldi xh, high(@0)
	ld r24, x+
	ld r25, x
	ldi r17, 0
	cpse r25, r17
	cpse r24, r17
	breq of
	.endmacro