/*
 * status_light_delay.asm
 *
 *  Created: 27.10.2015 16:01:10
 *   Author: Fabio
 */ 


 .include "m328pdef.inc"

 .dseg 
 .org $100
 time: .byte 2


 .cseg
 .org $00
 rjmp main



 .org OC2Aaddr
 rjmp octm2



 .org $60




 .macro inctime
	ldi xl, low(time)
	ldi xh, high(time)
	ld r24, x+
	ld r25, x
	adiw r25:r24, 1
	ldi xl, low(time)
	ldi xh, high(time)
	st x+, r24
	st x, r25
 .endmacro

 .macro dectime
	ldi xl, low(time)
	ldi xh, high(time)
	ld r24, x+
	ld r25, x
	sbiw r25:r24, 1
	ldi xl, low(time)
	ldi xh, high(time)
	st x+, r24
	st x, r25
 .endmacro

 .macro sutm2
	ldi r16, 0x02
	sts tccr2a, r16
	ldi r16, 0x03
	sts tccr2b, r16
	ldi r16, 0x02
	sts timsk2, r16
	ldi r16, 250
	sts ocr2a, r16
 .endmacro


 main:

 ldi xl, low(0)
 ldi xh, high(0)
 st x+, r24
 st x, r25

 ldi r16, 0x40
 out ddrd, r16
 ldi r16, 0x40
 out portd, r16

 sutm2
 
 sei

 ldi r24, low(1000)
 ldi r25, high(1000)


 loop:
	
	ldi xl, low(time)
	ldi xh, high(time)
	ld r24, x+
	ld r25, x
	ldi r17, 0
	cpse r24, r17
	cpse r25, r17
	breq green


 sei

 rjmp loop

 octm2:
 
 dectime
 
 reti

 green:
	sbis pind, 6
	sbi portd, 6
	sbic pind, 6
	cbi portd, 6
 ret